<?php
/**
 * @version $Id: bilansControleur.php 36 2009-11-17 20:58:49Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of GEC.
 *
 * GEC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GEC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

class bilansControleur extends applicationControleur{

  public $_aideMessage = 'Ces bilans servent  faire le point sur une comp&eacute;tence en particulier pour un &eacute;l&egrave;ve.
                          Vous pouvez cliquer sur chaque &eacute;lve pour retrouver l\'ensemble des comp&eacute;tences que vous avez &eacute;valu&eacute;es pour lui.
                          Ces comp&eacute;tences sont rang&eacute;es par comp&eacute;tence du socle commun.<br />
                          Pour information, un nombre limit&eacute; de comp&eacute;tences figurera sur le bulletin de cet &eacute;l&egrave;ve.
                          Vous devrez donc choisir parmis ces bilans lesquels figureront sur le bulletin de la p&eacute;riode.';

  /**
   *
   * @var string Rsultat du bilan pour la mthode eleveEtSocle (une lettre)
   */
  public $_bilanEvaluationValue = NULL;

  public function index(){

  } // index()

  /**
   * @todo : Penser  implmenter les priodes dfinies par des dates
   */
  public function perso(){

    $this->_aideMessage .= '<p class="green">La fiche de chaque &eacute;l&egrave;ve peut se d&eacute;placer avec la souris.</p>
                           <p class="red">Un calcul automatique est propos&eacute;. Il est accessible en cliquant sur le bas de la fiche de l\'&eacute;l&egrave;ve [Proposer].</p>';

    if(isset($_GET['limite'])){

      $_SESSION['classe_aff_bilan'] = $_GET['limite'];
      $_SESSION['type_aff_bilan']   = $_GET['type'];

    }

    # limite est l'id du groupe ou de la classe et type est 
    if (!isset ($_SESSION['classe_aff_bilan']) OR $_SESSION['type_aff_bilan'] == '' OR (isset($_GET['type']) AND $_GET['type'] == 'changer')){

      # On envoie la liste des classes et des groupes de cet utilisateurs
      $this->_arrayTexte = $this->user;

      $this->_vue = 'choisirAff';

    }else{

      $this->_aideMessage .= '<p>Vous pouvez faire des bilans rapidement en cliquant sur un &eacute;l&egrave;ve :</p>
                            <p>Explications : [socle][5] Lire et utiliser diff&eacute;rents langages <input type="text" />, signifie que la comp&eacute;tence
                            "Lire et utiliser diff&eacute;rents langages" est une comp&eacute;tence du socle commun, qu\'elle appartient au domaine 5.
                            Vous pouvez donc en faire un bilan en suivant la liste des &eacute;valuations qui suivent (en couleur).</p>';

      $periodeactive = PeriodePeer::getPeriodeActuelle($this->user->getRne());
      $dateDebutPeriodeActive = $periodeactive->getDebut();
      $dateFinPeriodeActive   = $periodeactive->getFin();

      $cr = new Criteria();
      $cr->addJoin(JControlePossesseurPeer::CONTROLE_ID, JControleResultatPeer::CONTROLE_ID, Criteria::INNER_JOIN);
      $cr->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      $criter1 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateFinPeriodeActive, Criteria::LESS_EQUAL);
      $criter2 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateDebutPeriodeActive, Criteria::GREATER_EQUAL);
      $criter1->addAnd($criter2);
      $cr->add($criter1);

      # La liste des utilisateurs  afficher
      $tab_liste_eleve = array();
      if ($_SESSION['type_aff_bilan'] == 'classe'){
        $liste_eleves = UtilisateurPeer::listeElevesCetteCLasse($_SESSION['classe_aff_bilan']);
        foreach ($liste_eleves as $eleve) {
          $tab_liste_eleve[] = $eleve->getId();
        }
      }elseif($_SESSION['type_aff_bilan'] == 'groupe'){
        $liste_eleves = UtilisateurPeer::listeElevesCeGroupe($_SESSION['classe_aff_bilan']);
        foreach ($liste_eleves as $eleve) {
          $tab_liste_eleve[] = $eleve->getUtilisateurId();
        }
      }

      $cr->add(JControleResultatPeer::UTILISATEUR_ID, $tab_liste_eleve, Criteria::IN);

      if ( $this->_params['info'] == 'trier' AND $_GET['trie'] == 'eleve' ){

        $cr->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
        $cr->add(JControleResultatPeer::UTILISATEUR_ID, $_GET['eleve'], Criteria::EQUAL);
        $cr->addAscendingOrderByColumn(UtilisateurPeer::NOM);
        $cr->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
        $liste = JControleResultatPeer::doSelectJoinAllExceptCompetence($cr);

      }elseif($this->_params['info'] == 'trier' AND $_GET['trie'] == 'competence'){

        $cr->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
        $cr->add(JControleResultatPeer::COMPETENCE_ID, $_GET['cptce'], Criteria::EQUAL);
        $cr->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);
        $liste = JControleResultatPeer::doSelectJoinAll($cr);

      }else{

        $cr->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL); // On enlve les rsultats sans rsultats :)
        $cr->addAscendingOrderByColumn(UtilisateurPeer::NOM);
        $cr->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
        $cr->addAscendingOrderByColumn(CompetencePeer::CPTCEGRP_ID);
        $cr->addAscendingOrderByColumn(CompetencePeer::COMPETENCE_ID);
        $cr->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
        $cr->addAscendingOrderByColumn(ControlePeer::NOMCOURT);
        $liste = JControleResultatPeer::doSelectJoinAll($cr);
      }
    

      $this->_arrayTexte = $liste;

    }
  } // perso()

  /**
   * Permet  un professeur de supprimer un bilan dj effectu
   */
  public function effacer(){
    if ($this->_params['info'] != ''){
      # on vrifie que ce bilan appartient bien  ce professeur
      $test = BilanPeer::retrieveByPK($this->_params['info']);
      if ($test->getProfesseurId() == $this->user->getId()){

        # on peut effacer
        BilanPeer::doDelete($test->getId());

        $this->setMessage('Bilan supprim&eacute; !');
        $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->getLogin()));
        exit();

      }else{
        logControleur::insertLog('pirate', 2, 'Modification url bilan_id='.$this->_params['info'], $this->user->getId());
        $this->setErreurMessage('Il ne faut pas modifier l\'url  la main !');
        $this->redirect_to(array('action'=>'index', 'controleur'=>'accueil'));
        exit();
      }
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }
  } // effacer()

  /**
   * Action qui permet de lister tous les rsultats d'un lve sur une comptence au cours de la priode pour un professeur
   */
  public function eleveEtCompetence(){

    if ($this->_requete->isGet() === true AND isset($_GET['cptce'])){

      $periodeactive = PeriodePeer::getPeriodeActuelle($this->user->getRne());
      $dateDebutPeriodeActive = $periodeactive->getDebut();
      $dateFinPeriodeActive   = $periodeactive->getFin();

      $c = new Criteria();
      $c->addJoin(JControlePossesseurPeer::CONTROLE_ID, JControleResultatPeer::CONTROLE_ID, Criteria::INNER_JOIN);
      $c->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_params['info'], Criteria::EQUAL);
      $c->add(JControleResultatPeer::COMPETENCE_ID, $_GET['cptce'], Criteria::EQUAL);
      $c->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
      $criter1 = $c->getNewCriterion(ControlePeer::CREATED_ON, $dateFinPeriodeActive, Criteria::LESS_EQUAL);
      $criter2 = $c->getNewCriterion(ControlePeer::CREATED_ON, $dateDebutPeriodeActive, Criteria::GREATER_EQUAL);
      $criter1->addAnd($criter2);
      $c->add($criter1);
      $c->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
      $c->addAscendingOrderByColumn(ControlePeer::NOMCOURT);
      $cptce = JControleResultatPeer::doSelectJoinAll($c);

      $this->_arrayTexte = $cptce;

      # On regarde maintenant si il existe un bilan pour cette comptence
      $c = new Criteria();
      $c->add(BilanPeer::ELEVE_ID, $this->_params['info']);
      $c->add(BilanPeer::COMPETENCE_ID, $_GET['cptce']);
      $criter1 = $c->getNewCriterion(BilanPeer::DATE, $dateFinPeriodeActive, Criteria::LESS_EQUAL);
      $criter2 = $c->getNewCriterion(BilanPeer::DATE, $dateDebutPeriodeActive, Criteria::GREATER_EQUAL);
      $criter1->addAnd($criter2);
      $c->add($criter1);
      $cherche = BilanPeer::doSelect($c);

      if (count($cherche) > 1){

        $this->_texte['warning'] = '<p class="red">Cette comp&eacute;tences connait d&eacute;j&agrave; 2 bilans pour cette p&eacute;riode et cet &eacute;l&egrave;ve !</p>';
        $this->_texte['couleur'] = $this->_texte['valeur'] = $this->_texte['id'] = NULL;

      }elseif(count($cherche) == 1){

        $couleurs = ValidationNiveauPeer::listeNiveauxValidation('color');
        $this->_texte['couleur']  = ' style="background-color:'.$couleurs[$cherche[0]->getResultat()].'"';
        $this->_texte['valeur']   = $cherche[0]->getResultat();
        $this->_texte['id']       = $cherche[0]->getId();
        $this->_texte['warning'] = NULL;

      }else{

        $this->_texte['couleur'] = $this->_texte['valeur'] = $this->_texte['warning'] = $this->_texte['id'] = NULL;

      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // eleveEtCompetence()

  public function eleveEtSocle(){

    # Les informations sur la comptence du socle sont l :
    $criter = new Criteria();
    $criter->add(CompetencePeer::TYPE, 'socle', Criteria::EQUAL);
    $criter->add(CompetencePeer::ID, $_GET['cptce'], Criteria::EQUAL);
    $test = CompetencePeer::doSelect($criter);

    # On teste pour savoir si le professeur a dj fait un bilan pour cette comptence
    $testons = BilanPeer::listeBilansCeProfesseurCetEleveCetteCompetenceCettePeriode($this->user, $this->_params['info'], $_GET['cptce']);
    if (!empty ($testons)){
      $this->_bilanEvaluationValue = $testons[0];
    }else{
      $this->_bilanEvaluationValue = new Bilan();
    }

    if (empty ($test)){
      $this->setErreurMessage('Cette comp&eacute;tence n\'appartient pas au socle commun, pr&eacute;venez votre administrateur !');
      logControleur::insertLog('pirate', 2, 'Modification url cptce='.$_GET['cptce'].'-C::bilansControleur-A::eleveEtSocle', $this->user->getId());
      $this->redirect_to(array('info'=>'pirate', 'action'=>'perso'));
      exit ();
    }elseif (count($test) == 1){
      $this->_texte = $test[0];
    }

    $periodeactive = PeriodePeer::getPeriodeActuelle($this->user->getRne());
    $dateDebutPeriodeActive = $periodeactive->getDebut();
    $dateFinPeriodeActive   = $periodeactive->getFin();

    $cr = new Criteria();
    $cr->setDistinct();
    $cr->addJoin(JControlePossesseurPeer::CONTROLE_ID, JControleResultatPeer::CONTROLE_ID, Criteria::INNER_JOIN);
    $cr->addJoin(JControleResultatPeer::CONTROLE_ID, ControlePeer::ID, Criteria::INNER_JOIN);
    $cr->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
    $cr->add(CompetencePeer::COMPETENCE_ID, $_GET['cptce'], Criteria::EQUAL);
    $cr->add(JControleResultatPeer::UTILISATEUR_ID, $this->_params['info'], Criteria::EQUAL);
    $cr->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
    $criter1 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateFinPeriodeActive, Criteria::LESS_EQUAL);
    $criter2 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateDebutPeriodeActive, Criteria::GREATER_EQUAL);
    $criter1->addAnd($criter2);
    $cr->add($criter1);
    $cr->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
    $cr->addAscendingOrderByColumn(ControlePeer::NOMCOURT);
    $this->_arrayTexte = JControleResultatPeer::doSelectJoinCompetence($cr);

  } // eleveEtSocle()

  /**
   * Permet de saisir et d'enregistrer tous ses bilans pour un lves
   */
  public function bilanRapideSocle(){

    if ($this->_requete->isPost() === true){

      # On vrifie qu'il existe au moins un contrle de ce professeur sur cet lve
      $c = new Criteria();
      $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_params['info'], Criteria::EQUAL);
      $c->addJoin(JControleResultatPeer::CONTROLE_ID, ControlePeer::ID, Criteria::INNER_JOIN);
      $c->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      $c->setLimit(1);
      $test = JControleResultatPeer::doSelect($c);
      if (empty ($test)){
        $this->setErreurMessage('Vous n\'avez jamais &eacute;valu&eacute; cet &eacute;l&egrave;ve !');
        logControleur::insertLog('pirate', 2, 'Modification url eleve='.$this->_params['info'].'-C::bilansControleur-A::bilanRapideSocle', $this->user->getId());
        $this->redirect_to(array('info'=>'pirate', 'action'=>'perso'));
      }
      $nbreCptce = count($this->_requete->socle);
      for($a = 0 ; $a < $nbreCptce ; $a++) {

        # On rcupre les donnes sur la comptence du bilan
        $cptce = CompetencePeer::retrieveByPK($this->_requete->socle[$a]);
        # quelques vrifications
        $testdate = explode ("/", $this->_requete->date[$a]);
        if (count($testdate) != 3){
          $this->setErreurMessage('Le format de la date n\'est pas correct ! Impossible d\'enregistrer !');
          $this->redirect_to(array('info'=>'erreur', 'action'=>'perso'));
        }else{
          $date = mktime(2, 0, 0, $testdate[1], $testdate[0], $testdate[2]);
        }
        # le rsultat
        $result_possibles = ValidationNiveauPeer::listeNiveauxValidation();
        //$this->affDebug($result_possibles);
        if (array_key_exists($this->_requete->bilan[$a], $result_possibles)){

          $resultat = $this->_requete->bilan[$a];
          //echo 'socle='.$this->_requete->socle[$a] . ' - bilan=' . $this->_requete->bilan[$a].' - user='.$this->_params['info'].'<br />';
          if (isset($this->_requete->_id[$a]) AND $this->_requete->_id[$a] != ''){
            $c = new Criteria();
            $c->add(BilanPeer::ID, $this->_requete->_id[$a]);
            $update = BilanPeer::doSelect($c);
            $insert = $update[0]; // on nerenvoit que le premier car il ne peut y avoir qu'un seul bilan avec cet ID
          }else{
            # c'set donc un nouveau bilan
            $insert = new Bilan();
          }
          $insert->setNom($cptce->getNomcourt()); // le nom de la comptence en rfrence
          $insert->setDate($date);
          $insert->setCreatedOn(date('U'));
          $insert->setProfesseurId($this->user->getId());
          $insert->setEleveId($this->_params['info']);
          $insert->setCompetenceId($this->_requete->socle[$a]);
          $insert->setResultat($resultat);
          $insert->setAppreciation($this->_requete->appreciation[$a]);
          $insert->setRne($this->user->getRne());

          $insert->save();

        }elseif($this->_requete->bilan[$a] == ''){
          // On ne fait rien puisque aucun rsultat n'a t saisi
        }else{
          $this->setErreurMessage('La lettre de validation n\'est pas correcte ! Impossible d\'enregistrer !');
          $this->redirect_to(array('info'=>'erreur', 'action'=>'perso'));
          exit();
        }

      }
      $this->setMessage('Bilan enregistr&eacute; !');
      $this->redirect_to(array('info'=>'enregistre', 'action'=>'perso'));
      exit();
    }
    //$this->affDebug($test);

  } // bilanRapideSocle()

  public function addBilanCptceHorsSocle(){
    if ($this->_requete->isPost() === true){
      // Il faut tester si cet lve a bien t valu sur cette comptence
      $c = new Criteria();
      $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_requete->eleve);
      $c->add(JControleResultatPeer::COMPETENCE_ID, $this->_requete->cptce);
      $c->add(JControleResultatPeer::RNE, $this->user->getRne());
      $test = JControleResultatPeer::doSelect($c);

      if (!empty ($test)){

        $test_date = explode("/", $this->_requete->date);
        if (count($test_date) == 3){
          $_date = mktime(2, 0, 0, $test_date[1], $test_date[0], $test_date[2]);
        }else{
          $this->setErreurMessage('Le format de la date doit &ecirc;tre JJ/MM/AAAA');
          $this->redirect_to(array('action'=>'eleveEtCompetence', 'info'=>$this->_requete->eleve, 'get'=>array('cptce'=>$this->_requete->cptce)));
          exit();
        }

        # On rcupre les informations de cette comptence
        $_cptce = CompetencePeer::retrieveByPK($this->_requete->cptce);

        if ($this->_requete->id != ''){
          $bilan = BilanPeer::retrieveByPK($this->_requete->id);
        }else{
          $bilan = new Bilan();
        }
        $bilan->setNom($_cptce->getNomcourt());
        $bilan->setDate($_date);
        $bilan->setCreatedOn(date("U"));
        $bilan->setCompetenceId($this->_requete->cptce);
        $bilan->setEleveId($this->_requete->eleve);
        $bilan->setProfesseurId($this->user->getId());
        $bilan->setResultat($this->_requete->resultat);
        $bilan->setRne($this->user->getRne());

        if ($bilan->save()){
          $this->setMessage('Bilan enregistr&eacute; !');
          $this->redirect_to(array('action'=>'eleveEtCompetence', 'info'=>$this->_requete->eleve, 'get'=>array('cptce'=>$this->_requete->cptce)));
          exit();
        }else{
          $this->setErreurMessage('Impossible d\'enregistrer ce bilan !');
          $this->redirect_to(array('action'=>'eleveEtCompetence', 'info'=>$this->_requete->eleve, 'get'=>array('cptce'=>$this->_requete->cptce)));
          exit();
        }

      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }

    }
  } //addBilanCptceHorsSocle()

  /**
   * Permet de voir dans un seul tableau tous les bilans de la priode actuelle
   */
  public function tousBilans(){

    $this->_aideMessage = '<p>Par dfaut, seules les comp&eacute;tences du socle sont visibles ici.
                          Le professeur peut voir toutes ses saisies en cliquant sur <img src="'.$this->_params['path'].'/www/images/ouvrir.png" alt="img" />.</p>';
    if (isset ($_GET['pp'])){
      $this->_aideMessage .= '<p class="red">Le professeur principal voit toutes les mati&egrave;res et peut de la m&ecirc;me fa&ccedil;on voir toutes les &eacute;valuations.</p>';
    }

    if ($this->_params['info'] !== false){

      $periodeactive = PeriodePeer::getPeriodeActuelle($this->user->getRne());
      $dateDebutPeriodeActive = $periodeactive->getDebut();
      $dateFinPeriodeActive   = $periodeactive->getFin();

      $cr = new Criteria();
      # Pour un bilan de PP, on affiche toutes les matires, sinon seulement les rsultats qu'il a mis lui mme
      if (isset($_GET['pp'])){
        # On vrifie que ce prof est bien pp de cette classe
        $auth_pp = false;
        foreach ($this->user->getJProfesseurPrincipalClassess() as $joinPP) {
          if ($joinPP->getClasseId() == $_GET['pp']){
            $auth_pp = true;
          }
        }
        if ($auth_pp === false){
          $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::L'.__LINE__, $this->user->getId());
        }
        $cr->addJoin(ControlePeer::ID, JControleResultatPeer::CONTROLE_ID);
        $cr->addJoin(GrillePeer::ID, ControlePeer::GRILLE_ID);

      }else{
        $cr->addJoin(JControlePossesseurPeer::CONTROLE_ID, JControleResultatPeer::CONTROLE_ID, Criteria::INNER_JOIN);
        $cr->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      }
      
      $criter1 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateFinPeriodeActive, Criteria::LESS_EQUAL);
      $criter2 = $cr->getNewCriterion(ControlePeer::CREATED_ON, $dateDebutPeriodeActive, Criteria::GREATER_EQUAL);
      $criter1->addAnd($criter2);
      $cr->add($criter1);

      # La liste des utilisateurs  afficher
      $tab_liste_eleve = array();
      if ($_GET['type'] == 'classe'){
        $liste_eleves = UtilisateurPeer::listeElevesCetteCLasse($this->_params['info']);
        foreach ($liste_eleves as $eleve) {
          $tab_liste_eleve[] = $eleve->getId();
        }
      }elseif($_GET['type'] == 'groupe'){
        $liste_eleves = UtilisateurPeer::listeElevesCeGroupe($this->_params['info']);
        foreach ($liste_eleves as $eleve) {
          $tab_liste_eleve[] = $eleve->getUtilisateurId();
        }
      }

      $cr->add(JControleResultatPeer::UTILISATEUR_ID, $tab_liste_eleve, Criteria::IN);

      $cr->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL); // On enlve les rsultats sans rsultat
      $cr->addAscendingOrderByColumn(UtilisateurPeer::NOM);
      $cr->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
      if (isset($auth_pp) AND $auth_pp === true){
        $cr->addAscendingOrderByColumn(GrillePeer::MATIERE_ID); // on range par matire si c'est un PP
      }
      $cr->addAscendingOrderByColumn(CompetencePeer::COMPETENCE_ID); // on range par cptces du socle
      $cr->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);
      $cr->addAscendingOrderByColumn(CompetencePeer::CPTCEGRP_ID);
      $cr->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
      $cr->addAscendingOrderByColumn(ControlePeer::NOMCOURT);
      $liste = JControleResultatPeer::doSelectJoinAll($cr);

      $this->_arrayTexte = $liste;

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // tousBilans()

  /**
   * Permet  un chef d'tablissement de voir tous les rsultats
   */
  public function voirEtab(){

    $this->_aideMessage = '<p>Vous pouvez voir l\'ensemble des r&eacute;sultats d\'un &eacute;l&egrave;ve en passant par sa classe.</p>
                           <p class="green">Les "moyennes" visibles ici sont le fait d\'un calcul par l\'application et pas le fruit du professeur.</p>';

    # Si il y a une demande de faite, on l'envoie en ajax
    if ($this->_requete->isPost() === true){

      if ($this->_requete->type == 'classe'){

        # On vrifie si cette classe est bien de cet tablissement en appelant uniquement des lves de cet tablissement
        $c = new Criteria();
        $c->add(UtilisateurPeer::CLASSE_ID, $this->_requete->_id);
        $c->add(UtilisateurPeer::RNE, $this->user->getRne());
        $c->addAscendingOrderByColumn(UtilisateurPeer::NOM);
        $c->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
        $test_classe = UtilisateurPeer::doSelect($c);

        echo '<p class="red">' . $test_classe[0]->getClasse()->getNom() . '</p>';
        foreach ($test_classe as $eleve) {
          echo '
          <span class="lien" onclick="ajaxUpdater(\'aff_result2\', \'eleve\', '.$eleve->getId().', \'../voirEtab/'.$eleve->getId().'\');">
            '.$eleve->GetNom().' '.$eleve->getPrenom().'
          </span><br />';
        }

      }elseif($this->_requete->type == 'chercher'){

        echo 'On cherche, on cherche !';

      }elseif($this->_requete->type == 'eleve'){

        # S'il s'agit d'un lve qui demande ses rsultats, on vrifie qu'il demande bien les siens
        if ($this->user->getRole()->getNom() == 'eleve'){
          if ($this->_requete->_id != $this->user->getId()){
            $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
          }
        }

        if ($this->_requete->_id != $this->_params['info']){
          $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
        }

        $this->ajaxVoirEleveBilans();

      }

      exit(); // ajax

    }

    # Sinon on envoie la liste des classes de l'tablissement
    $c = new Criteria();
    $c->add(ClassePeer::RNE, $this->user->getRne());
    $c->addAscendingOrderByColumn(ClassePeer::NOMLONG);
    $this->_texte = ClassePeer::doSelect($c);

  } // voirEtab()

  public function ajaxVoirEleveBilans(){

        # On envoie alors les rsultats de cet lve
        $periodeactive = PeriodePeer::getPeriodeActuelle($this->user->getRne());

        $c = new Criteria();
        $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_requete->_id);
        $c->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
        $c->addJoin(JControleResultatPeer::COMPETENCE_ID, CompetencePeer::ID, Criteria::LEFT_JOIN);
        $c->addJoin(JControleResultatPeer::CONTROLE_ID, ControlePeer::ID, Criteria::LEFT_JOIN);
        $c->addJoin(ControlePeer::GRILLE_ID, GrillePeer::ID, Criteria::LEFT_JOIN);
        $c->addJoin(GrillePeer::MATIERE_ID, MatierePeer::ID, Criteria::LEFT_JOIN);
        $criter1 = $c->getNewCriterion(ControlePeer::CREATED_ON, $periodeactive->getFin(), Criteria::LESS_EQUAL);
        $criter2 = $c->getNewCriterion(ControlePeer::CREATED_ON, $periodeactive->getDebut(), Criteria::GREATER_EQUAL);
        $criter1->addAnd($criter2);
        $c->add($criter1);
        $c->addAscendingOrderByColumn(MatierePeer::NOMLONG); // on range par matire
        $c->addAscendingOrderByColumn(CompetencePeer::COMPETENCE_ID); // on range par cptces du socle
        $c->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);
        $c->addAscendingOrderByColumn(CompetencePeer::CPTCEGRP_ID);
        $c->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
        $c->addAscendingOrderByColumn(ControlePeer::NOMCOURT);

        $resultats = JControleResultatPeer::doSelect($c);

        $m_matiere  = false;
        $m_socle    = false;
        $couleurs   = ValidationNiveauPeer::listeNiveauxValidation('color');
        $niveaux    = ValidationNiveauPeer::listeNiveauxValidation('niveau');
        $total      = array();

        if (empty ($resultats)){
          $eleve = UtilisateurPeer::retrieveByPK($this->_requete->_id);
          echo '<p class="red">Aucun r&eacute;sultat n\'est disponible pour '.$eleve->getPrenom().' '.$eleve->getNom().' sur cette p&eacute;riode !</p>';
          exit();
        }else{
          echo '<p class="green">'.$resultats[0]->getUtilisateur()->getPrenom().' '.$resultats[0]->getUtilisateur()->getNom().'</p>';
        }

        foreach ($resultats as $jResult) {

          # On change de matire
          if ($m_matiere != $jResult->getControle()->getGrille()->getMatiereId()){
            # d'abord, on termine le travail de la matire prcdente s'il y en a une
            if ($m_socle !== false){
              $moy = ValidationNiveauPeer::calculeMoyenne($nbre_resultats, $total, 'defaut', 'lettre');
              $aff_couleurs = (array_key_exists($moy, $couleurs)) ? ' style="background-color:'.$couleurs[$moy].';"' : NULL;
              $aff_moy      = (array_key_exists($moy, $couleurs)) ? $moy : '-';
              $aff_tr .= '
                    <td class="t">'.$aff_bis_results.'</td>
                    <td title="Moyenne calcul&eacute;e automatiquement sans intervention du professeur" class="moz2 textcenter"'.$aff_couleurs.'>'.$aff_moy.'</td>
                    </tr>';
              echo $aff_tr;
              $total = array();
              $aff_bis_results  = NULL;
              $nbre_resultats   = 0;
              $aff_tr           = NULL;
            }
            # Puis on affiche la nouvelle matire
            echo '<table class="table">
                  <tr>
                    <td colspan="3" class="red">'.$jResult->getControle()->getGrille()->getMatiere()->getNomlong().'</td>
                    <td class="t"></td>
                  </tr>';
            $m_matiere = $jResult->getControle()->getGrille()->getMatiereId();
          }

          # On change de comptence du socle
          if ($m_socle != $jResult->getCompetence()->getCompetenceId()){
            if ($m_socle !== false AND !is_null($aff_tr)){
              $moy = ValidationNiveauPeer::calculeMoyenne($nbre_resultats, $total, 'defaut', 'lettre');
              $aff_couleurs = (array_key_exists($moy, $couleurs)) ? ' style="background-color:'.$couleurs[$moy].';"' : NULL;
              $aff_moy      = (array_key_exists($moy, $couleurs)) ? $moy : '-';
              $aff_tr .= '
                    <td class="t">'.$aff_bis_results.'</td>
                    <td title="Moyenne calcul&eacute;e automatiquement sans intervention du professeur" class="moz2 textcenter"'.$aff_couleurs.'>'.$aff_moy.'</td>
                    </tr>';
              echo $aff_tr;
              $total = array();
            }

            # Ici, on va trouver une solution pour afficher les ressources disponibles url et/ou fichier
            # Dans un premier temps, le lien emmne  une page o on va lister les ressources disponibles pour cette comptence
            $aff_ressources = ($this->user->getRole()->getNom() == 'eleve') ?
                              '<a href="../../remediations/eleve/'.$jResult->getCompetence()->getCompetenceId().'"><img src="'.$this->_params['path'].'/www/images/web.png" alt="web" title="Cliquer pour acc&eacute;der &agrave; une ressource"></a>' :
                              '&nbsp;&nbsp;&nbsp;';

            $aff_tr = '<tr>
                    <td class="t">'.$aff_ressources.'</td>
                    <td>'.$jResult->getCompetence()->getCompetenceRelatedByCompetenceId()->getNomlong().'</td>
                    ';
            $nbre_resultats = 1;
            $total[] = $niveaux[$jResult->getResultat()];
            $m_socle = $jResult->getCompetence()->getCompetenceId();
            $aff_bis_results = $jResult->getResultat() . ' - ';
          }else{
            # Comme on ne change pas de comptence du socle, on reste sur le mme affichage
            ++$nbre_resultats;
            $total[] = $niveaux[$jResult->getResultat()];
            $aff_bis_results .= $jResult->getResultat() . ' - ';
          }

        } // foreach ($resultats as $jResult) {
        # On affiche le dernier qui va bien
        $moy = ValidationNiveauPeer::calculeMoyenne($nbre_resultats, $total, 'defaut', 'lettre');
              $aff_couleurs = (array_key_exists($moy, $couleurs)) ? ' style="background-color:'.$couleurs[$moy].';"' : NULL;
              $aff_moy      = (array_key_exists($moy, $couleurs)) ? $moy : '-';
              $aff_tr .= '
                    <td class="t">'.$aff_bis_results.'</td>
                    <td title="Moyenne calcul&eacute;e automatiquement sans intervention du professeur" class="moz2 textcenter"'.$aff_couleurs.'>'.$aff_moy.'</td>
                    </tr>';
              echo $aff_tr;

  }

  /**
   * Permet  un lve de voir ses rsultats et de suivre une ressource en rapport avec la comptence
   */
  public function eleve(){

    # On vrifie un peu toude mme
    if ($this->_requete->_id != $this->user->getId()){
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
    }

    $this->ajaxVoirEleveBilans();

    exit(); // ajax
  }

}
?>