<?php
/**
 * @version $Id: classesControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

class classesControleur extends applicationControleur {

  /**
   * Liste les classes et propose un formulaire pour en ajouter
   */
  public function index(){

    $this->_title = $this->_titre = 'Gestion des classes';

    $form = new formulaireHtml(array('name'=>'ajouterClasse', 'action'=>'ajouter', 'forme'=>'p'), $this->_params);
    $form->addInput(array('label'=>'Nom : ', 'name'=>'nom', 'value'=>''));
    $form->addInput(array('label'=>'Nom long : ', 'name'=>'nomlong', 'value'=>'', 'size'=>60));
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

    $c = new Criteria();
    $c->add(ClassePeer::RNE, $this->user->getRne());
    $c->addAscendingOrderByColumn(ClassePeer::NOM);
    $this->_arrayTexte = ClassePeer::doSelect($c);

  }//index()

  public function ajouter(){
    if ($this->_requete->isPost() === true){
      #On enregistre
      $enre = new Classe();
      $enre->setNom(htmlentities($this->_requete->ajouterClasse['nom']));
      $enre->setNomlong(htmlentities($this->_requete->ajouterClasse['nomlong']));
      $enre->setRne($this->user->getRne());
      if ($enre->save()){
        $this->setMessage('Classe enregistr&eacute;e !');
        $this->redirect_to(array('action'=>'index', 'info'=>'enregistre'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\'ajouter cette classe !');
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur_mysql'));
        exit();
      }
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }
  } // ajouter()

  public function effacer(){

    if ($this->_params['info'] != ''){

      # C'est un admin
      if (ClassePeer::doDelete($this->_params['info'])){
        $this->setMessage('Classe supprim&eacute;e !');
        $this->redirect_to(array('action'=>'index', 'info'=>'supprimee'));
        exit();
      }else{
        $this->setErreurMessage('Impossible de supprimer cette classe !');
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }
  }

}

?>