<?php
/**
 * @version $Id: discussionsControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

class discussionsControleur extends applicationControleur{

  public function index(){

    # Le formulaire de cration d'une nouvelle discussion
    $form = new formulaireHtml(array('name'=>'ajouterDiscussion', 'forme'=>'p', 'action'=>'ajouter'), $this->_params);
    $form->addInput(array('name'=>'nom', 'label'=>'Nom : '));
    $form->addInput(array('name'=>'debutjour', 'label'=>'Date de dbut de la r&eacute;union : ', 'title'=>'Sous la forme jj/mm/YYYY'));
    $form->addInput(array('name'=>'debutheure', 'label'=>'Heure de d&eacute;but de la r&eacute;union : ', 'title'=>'Sous la forme hh:mm'));
    $form->addInput(array('name'=>'finjour', 'label'=>'Date de fin de la r&eacute;union : ', 'title'=>'Sous la forme jj/mm/YYYY'));
    $form->addInput(array('name'=>'finheure', 'label'=>'Heure de fin de la r&eacute;union : ', 'title'=>'Sous la forme hh:mm'));
    $form->addSelect(array('name'=>'participants', 'label'=>'Participants (*) : ', 'multiple'=>'on'), UtilisateurPeer::listeProfesseursForSelect());
    $form->addLegende('<p class="italic">(*) Pensez &agrave; vous ajouter &agrave; la liste des participants</p>');
    $form->addTextArea(array('name'=>'ordredujour', 'label'=>'Ordre du jour de la r&eacute;union', 'style'=>'width:100%;height:100px;'));
    $form->addInput(array('type'=>'submit', 'name'=>'ajouter', 'value'=>'Ajouter'));

    $this->form = $form;

    $cr = new Criteria();
    $cr->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
    $cr->add(DiscussionPeer::FIN, date('U'), Criteria::GREATER_EQUAL);
    $this->_arrayTexte = JDiscussionUtilisateursPeer::doSelectJoinDiscussion($cr);

  } //index()

  public function ajouter(){

    if ($this->_requete->isPost() === true){

      $new = new Discussion();
      $new->setCreatedOn(date('U'));
      $new->setNom(htmlentities($this->_requete->ajouterDiscussion['nom']));
      $new->setOrdredujour(htmlentities($this->_requete->ajouterDiscussion['ordredujour']));
      # On traite la date de dbut
      $jour = explode("/", $this->_requete->ajouterDiscussion['debutjour']);
      $heure = explode(":", $this->_requete->ajouterDiscussion['debutheure']);
      $new->setDebut(mktime($heure[0], $heure[1], 0, $jour[1], $jour[0], $jour[2]));
      $jourfin = explode("/", $this->_requete->ajouterDiscussion['finjour']);
      $heurefin = explode(":", $this->_requete->ajouterDiscussion['finheure']);
      $new->setfin(mktime($heurefin[0], $heurefin[1], 0, $jourfin[1], $jourfin[0], $jourfin[2]));

      if ($new->save()){
        # Il faut galement enregistrer la liste des participants
        foreach ($this->_requete->ajouterDiscussion['participants'] as $userId) {
          $newuser = new JDiscussionUtilisateurs();
          $newuser->setDiscussion($new);
          $newuser->setUtilisateurId($userId);
          $newuser->save();
        }
        $this->redirect_to(array('action'=>'index', 'info'=>'enregistre'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\'enregistrer cette discussion, il y peut-&ecirc;tre une erreur dans la saisie !');
        logControleur::insertLog('erreur', 0, 'Impossible d\'enregistrer discussion :: '.$jour.'-'.$heure.'-'.$jourfin.'-'.$heurefin, $this->user->getId());
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // ajouter()

  public function effacer(){

  } // effacer()

  public function discussion(){
    # On commence par vrifier si cet utilisateur peut participer  cette discussion
    $test = DiscussionPeer::retrieveByPK($this->_params['info']);
    if (empty ($test)){
      $this->setErreurMessage('Cette discussion n\'existe pas, il ne faut pas modifier l\'adresse de votre navigateur &agrave; la main !');
      logControleur::insertLog('pirate', 1, 'Modifie URL manuellement : C::'.__CLASS__.' M::'.__METHOD__, $this->user->getId());
      $this->redirect_to(array('action'=>'index', 'info'=>'pirate'));
      exit();
    }else{
      # On vrifie alors si cet utilisateur peut participer et si elle est commence
      $marqueur = false;
      foreach ($test->getJDiscussionUtilisateurss() as $joinUser) {
        if ($joinUser->getUtilisateur()->getId() == $this->user->getId()){
          $marqueur = true;
        }
      }
      if ($marqueur === false){
        $this->setErreurMessage('Vous n\'&ecirc;tes pas inscrit &agrave; cette discussion !');
        logControleur::insertLog('pirate', 1, 'Modifie URL manuellement : C::'.__CLASS__.' M::'.__METHOD__, $this->user->getId());
        $this->redirect_to(array('action'=>'index'));
        exit();
      }
      if ($test->getDebut() > date('U')){
        $this->setErreurMessage('Cette discussion ne commence que le '.date("d/m/Y H:i", $test->getDebut()));
        $this->redirect_to(array('action'=>'index'));
        exit();
      }
      $_SESSION['discussion'] = $this->_params['info'];
      $_SESSION['echange_ID'] = 0;
      $_SESSION['marqueurEchange'] = false; // pour savoir si on change d'auteur
      $this->_arrayTexte = $test;
    }

  } // discussion()

  public function ajaxEnvoyer(){

    # On vrifie si cet utilisateur peut crire sur cette discussion
    if ($_SESSION['discussion'] == ''){
      echo 'INTERDIT !';
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }
    # On a toutes les infos pour crire dans la base le message
    if ($this->_requete->isPost() === true){
      $new = new Echange();
      $new->setDiscussionId($_SESSION['discussion']);
      $new->setUtilisateur($this->user);
      $new->setPhrase(htmlentities(utf8_decode($this->_requete->_id)));
      $new->save();
    }
    exit(); // ajax
  } // ajaxEnvoyer()

  public function ajaxRecevoir(){

    if ($this->_requete->isPost() === true){
      $cr = new Criteria();
      $cr->add(EchangePeer::DISCUSSION_ID, $_SESSION['discussion'], Criteria::EQUAL);
      //$cr->add(EchangePeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      //$cr->add(EchangePeer::ID, $_SESSION['echange_ID'], Criteria::GREATER_THAN);
      $cr->setLimit(25);
      $cr->addDescendingOrderByColumn(EchangePeer::ID);
      $test = EchangePeer::doSelect($cr);

      foreach ($test as $envoi) {
        if ($_SESSION['marqueurEchange'] == $envoi->getUtilisateurId()){
          $threepts = '... ';
        }else{
          $threepts = NULL;
        }
        $_SESSION['marqueurEchange'] = $envoi->getUtilisateurId();
        echo '
        <p>['.$envoi->getUtilisateur()->getPrenom().' '.$envoi->getUtilisateur()->getNom().'] : '.$threepts.$envoi->getPhrase().'</p>
        ';
        $_SESSION['echange_ID'] = $envoi->getId();
      }

    }else{
      echo 'erreur - C::'.__CLASS__.' - M::'.__METHOD__;
    }

    exit(); //ajax
  } // ajaxRecevoir()

}
?>