<?php
/**
 * @version $Id: droitsControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
   

// Controleur des droits

class droitsControleur extends applicationControleur{

  public function index(){

    $this->_aideMessage = 'Seul le superadmin a tous les droits sur l\'application, les autres roles peuvent avoir des droits entirement paramtrables.';

    $formulaire = new formulaireHtml(array('name'=>'ajouterdroit', 'forme'=>'p', 'action'=>'ajouter'), $this->_params);
    $formulaire->addSelect(array('name'=>'role', 'label'=>'R&ocirc;le : '), rolePeer::listeRolesForSelect());
    $formulaire->addInput(array('name'=>'module', 'label'=>'Module : '));
    $formulaire->addInput(array('name'=>'controleur', 'label'=>'Controleur : '));
    $formulaire->addInput(array('name'=>'action', 'label'=>'Action : '));
    $formulaire->addInput(array('type'=>'submit', 'name'=>'ajouter', 'value'=>'Ajouter ce droit'));

    $this->form = $formulaire;

    $cr = new Criteria();
    $cr->addAscendingOrderByColumn(droitPeer::ROLE_ID);
    $cr->addAscendingOrderByColumn(droitPeer::MODULE);
    $cr->addAscendingOrderByColumn(droitPeer::CONTROLEUR);
    $cr->addAscendingOrderByColumn(droitPeer::ACTION);
    $this->_arrayTexte = droitPeer::doSelect($cr);


  }

  /**
   * @todo : Il faudra utiliser le module de php qui permet de rcuprer les mthodes d'une classe
   * et ne permettre d'assurer des droits que sur du code qui existe dj - API ReflexionClass
   */
  public function ajouter(){

    if ($this->_requete->isPost() === true){
      $newDroit = new droit();
      $newDroit->setRoleId($this->_requete->ajouterdroit["role"]);
      $newDroit->setModule(htmlentities($this->_requete->ajouterdroit["module"]));
      $newDroit->setControleur(htmlentities($this->_requete->ajouterdroit["controleur"]));
      $newDroit->setAction(htmlentities($this->_requete->ajouterdroit["action"]));

      if ($newDroit->save()){
        $this->redirect_to(array('action'=>'index'));
      }else{
        $_SESSION["erreurMsg"] = 'Impossible d\'ajouter ce droit';
        $this->redirect_to(array('action'=>'index', 'info'=>'bad'));
      }

    }
  }

  public function effacer(){

    if ($this->_requete->isGet() === true AND $this->_requete->getGet('e') == 'r'){
      // On efface
      $eff = droitPeer::doDelete($this->_params["info"]);

      $this->redirect_to(array('action'=>'index', 'info'=>'efface'));
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  }

} 
?>