<?php
/**
 * @version $Id: odtControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

class odtControleur extends applicationControleur{

  private function _includeODT(){
    require 'libexterne/ooo/library/odf.php';
  }

  private function _chargeModele($modele){
    return 'app/ressources/'.$modele.'.odt';
  }

  public function grille(){
    $this->_includeODT();
    $odf = new odf($this->_chargeModele('test'));

    # On rcupre la liste des comptences de la grille
    $c = new Criteria();
    $c->add(JGrilleCompetencePeer::GRILLE_ID, $this->_params['info']);
    $listeArticles = JGrilleCompetencePeer::doSelectJoinCompetence($c);

    # On vrifie si cet utilisateur peut utiliser cette grille
    if ( empty($listeArticles) OR $listeArticles[0]->getGrille()->getUtilisateurId() != $this->user->getId()){
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      exit();
    }

    $article = $odf->setSegment('articles');
    foreach($listeArticles AS $element) {
      $article->titreArticle(html_entity_decode($element->getCompetence()->getNomcourt()));
      $article->merge();
    }
    $odf->mergeSegment($article);

    $odf->exportAsAttachedFile('grille'.$listeArticles[0]->getGrilleid().'.odt');
    exit();
  }
}

?>