<?php
/**
 * @version $Id: remediationsControleur.php 36 2009-11-17 20:58:49Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

// Controleur des remdiations

class remediationsControleur extends applicationControleur{

  public function index(){

  } // index()

  public function suivi(){

  } // suivi()

  public function creer(){

    $this->_aideMessage = '';

    $form = new formulaireHtml(array('name'=>'ajouterRessource', 'action'=>'ajouter', 'enctype'=>'multipart/form-data'), $this->_params);
    $form->addLegende('<p>');
    $form->addInput(array('name'=>'designation', 'label'=>'Nom de la ressource : ', 'size'=>80));
    $form->addLegende('</p>');
    $form->addLegende('<p><span class="italic">Le type de ressource </span> ');
    $form->addInput(array('type'=>'radio', 'title'=>'Lien internet vers une ressource sans http:// au d&eacute;but', 'id'=>'idAddUrl', 'name'=>'type', 'value'=>'url', 'js'=>'onclick="cacherDiv(\'idInputDoc\');afficherDiv(\'idInputUrl\');"', 'label'=>'url : ', 'checked'=>'on'));
    $form->addInput(array('type'=>'radio', 'title'=>'Fichier  t&eacute;l&eacute;charger pour les &eacute;l&egrave;ves', 'id'=>'idAddDoc', 'name'=>'type', 'value'=>'doc', 'js'=>'onclick="afficherDiv(\'idInputDoc\');cacherDiv(\'idInputUrl\');";', 'label'=>'Fichier : '));
    $form->addLegende('</p><p id="idInputDoc" style="display:none;">');
    $form->addInput(array('type'=>'file', 'size'=>80, 'name'=>'fichier', 'label'=>'Fichier : '));
    $form->addLegende('</p><p id="idInputUrl" style="display:block;">');
    $form->addInput(array('type'=>'input', 'size'=>80, 'name'=>'url', 'label'=>'URL : '));
    $form->addLegende('<p>');

    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

    $c = new Criteria();
    $c->add(RessourcePeer::RNE, $this->user->getRne());
    $c->add(RessourcePeer::UTILISATEUR_ID, $this->user->getId());
    $c->addAscendingOrderByColumn(RessourcePeer::DESIGNATION);
    $this->_arrayTexte = RessourcePeer::doSelect($c);

  } // creer()

  public function ajouter(){

    if ($this->_requete->isPost() === true){

      # LEs vrifications d'usage
      if ($this->_requete->ajouterRessource['designation'] == ''){
        $this->setErreurMessage('Il faut donner un nom pour cette ressource !');
        $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
        exit();
      }


      # On peut enregistrer
      $add = new Ressource();
      $add->setCreatedOn(date("U"));
      $add->setDesignation(htmlentities($this->_requete->ajouterRessource['designation']));
      $add->setMatiereId($this->user->getMatiereId());
      $add->setRne($this->user->getRne());
      $add->setUtilisateur($this->user);
      if ($this->_requete->ajouterRessource['type'] == 'url'){
        $add->setType('url');
        # On vrifie l'url
        if ($this->_requete->ajouterRessource['url'] == ''){
          $this->setErreurMessage('Il faut donner un lien internet (url) pour cette ressource !');
          $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
          exit();
        }
        // Faut-il la tester ? difficile mais faisable pour dterminer si elle est valide mais pas si elle est srieuse
        if (substr($this->_requete->ajouterRessource['url'], 0, 7) == 'http://'){
          $add->setAdresse(substr($this->_requete->ajouterRessource['url'], 7));
        }else{
          $add->setAdresse($this->_requete->ajouterRessource['url']);
        }
      }elseif($this->_requete->ajouterRessource['type'] == 'doc'){

        if ($_FILES['ajouterRessource']['name']['fichier'] == ''){
          $this->setErreurMessage('Il faut choisir un fichier pour cette ressource !');
          $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
          exit();
        }

        # On dtermine une liste de type de fichiers autoriss
        $add->setType('doc');
        # On enregistre le fichier dans /app/ressources/
        $fichiers_autorises = array('pdf', 'doc', 'docx', 'odt', 'xls', 'ods', 'jpg', 'png');
        $extension = substr($_FILES['ajouterRessource']['name']['fichier'], -3);
        if (in_array($extension, $fichiers_autorises)){
          $_name_stocke = md5($_FILES['ajouterRessource']['tmp_name']['fichier'].rand(0, 99)).rand(10, 50);
          $nom_fichier = $_name_stocke.'.'.$extension;
          $add->setAdresse($nom_fichier);
          if (move_uploaded_file($_FILES['ajouterRessource']['tmp_name']['fichier'], 'app/ressources/'.$nom_fichier) !== false){
            // Rien
          }else{
            $this->setErreurMessage('Impossible d\'enregistrer ce fichier !');
            $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
            exit();
          }
        }else{
          $this->setErreurMessage('Il faut choisir un fichier autoris&eacute; ('.implode(", ", $fichiers_autorises).') pour cette ressource !');
          $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
          exit();
        }

      }else{
        $this->redirect_to(array());
        exit();
      }

      if ($add->save()){
        $this->setMessage('Ressource enregistr&eacute;e !');
        $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\'enregistrer cette ressource !');
        $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
        exit();
      }

    }

  } // ajouter()

  /**
   * Permet d'effacer une ressource
   */
  public function effacer(){

    $test = RessourcePeer::retrieveByPK($this->_params['info']);

    if ($test->getUtilisateurId() != $this->user->getId() AND $test->getRne() == $this->user->getRne()){
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
    }else{
      $test->delete();
      $this->setMessage('Ressource effac&eacute;e !');
      $this->redirect_to(array('action'=>'creer', 'info'=>'perso'));
      exit();
    }

  } // effacer()

  /**
   * Permet de modifier une ressource
   */
  public function modifier(){

    $test = RessourcePeer::retrieveByPK($this->_params['info']);

    if ($test->getUtilisateurId() != $this->user->getId() AND $test->getRne() == $this->user->getRne()){
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
    }else{

      # Si le formulaire est envoy, on le traite
      if ($this->_requete->isPost() === true){

        # On peut alors mettre  jour la ressource
        $test->setDesignation($this->_requete->modifier['designation']);
        if ($test->getType() == 'url'){
          $test->setAdresse($this->_requete->modifier['adresse']);
        }
        if ($test->save()){
          $this->setMessage('Ressource mise &agrave; jour !');
          $this->redirect_to(array('action'=>'creer', 'info'=>'perso'));
          exit();
        }else{
          $this->setErreurMessage('Impossible de mettre &agrave; jour cette ressource !');
        }

      }

        $form = new formulaireHtml(array('name'=>'modifier', 'action'=>'modifier','info'=>$this->_params['info'], 'forme'=>'p'), $this->_params);
        $form->addInput(array('type'=>'hidden', 'name'=>'id', 'value'=>$this->_params['info']));
        $form->addInput(array('type'=>'text', 'size'=>80, 'name'=>'designation', 'value'=>$test->getDesignation(), 'label'=>'D&eacute;signation : '));
        if ($test->getType() == 'url'){
          $form->addInput(array('type'=>'text', 'size'=>80, 'name'=>'adresse', 'value'=>$test->getAdresse(), 'label'=>'Url compl&egrave;te : '));
        }
        $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

        $this->form = $form;

    }

  } // modifier()

  /**
   * Permet de proposer un formulaire au professeur coordinateur pour
   */
  public function lier(){

    if ($this->_requete->isPost() === true AND is_array($this->_requete->lier)){
      if ($this->_requete->lier['ressource'] == '0'){
        $_SESSION['cptce'] = $this->_requete->lier['competence'];
        $this->setErreurMessage('Vous devez choisir une ressource !');
        $this->redirect_to(array('action'=>'lier', 'info'=>'perso'));
        exit();
      }
      if ($this->_requete->lier['competence'] == '0'){
        $_SESSION['ress'] = $this->_requete->lier['ressource'];
        $this->setErreurMessage('Vous devez choisir une comp&eacute;tence !');
        $this->redirect_to(array('action'=>'lier', 'info'=>'perso'));
        exit();
      }
      if ($this->_requete->lier['validation'] == '0'){
        $_SESSION['ress'] = $this->_requete->lier['ressource'];
        $_SESSION['cptce'] = $this->_requete->lier['competence'];
        $this->setErreurMessage('Vous devez choisir un niveau de validation !');
        $this->redirect_to(array('action'=>'lier', 'info'=>'perso'));
        exit();
      }
      $_SESSION['ress'] = $_SESSION['cptce'] = NULL;
      # On peut alors enregistrer l'association
      $add = new JCompetenceRessources();
      $add->setCompetenceId($this->_requete->lier['competence']);
      $add->setRessourceId($this->_requete->lier['ressource']);
      $add->setMatiereId($this->user->getMatiereId());
      $add->setRne($this->user->getRne());
      $add->setValidation($this->_requete->lier['validation']);

      if ($add->save()){
        $this->setMessage('Association enregistr&eacute;e !');
        $this->redirect_to(array('action'=>'lier', 'info'=>'perso'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\'enregistrer cette association !');
        $this->redirect_to(array('action'=>'lier', 'info'=>'perso'));
        exit();
      }

    }

    $sel_ress = isset($_SESSION['ress']) AND !is_null($_SESSION['ress']) ? $_SESSION['ress'] : NULL;
    $sel_cptc = isset($_SESSION['cptce']) AND !is_null($_SESSION['cptce']) ? $_SESSION['cptce'] : NULL;

    $form = new formulaireHtml(array('name'=>'lier', 'action'=>'lier'), $this->_params);
    $form->addSelect(array('name'=>'competence', 'limite'=>80, 'selected'=>$sel_cptc), CompetencePeer::listeCptecesAvecPreferenceForSelect('toutes', $this->user));
    $form->addSelect(array('name'=>'ressource', 'selected'=>$sel_ress), RessourcePeer::listeRessourcesForSelect($this->user));
    $form->addSelect(array('name'=>'validation'), ValidationNiveauPeer::listeNiveauxValidationForSelect());

    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

    $_SESSION['ress'] = $_SESSION['cptce'] = NULL;

    $c = new Criteria();
    $c->add(JCompetenceRessourcesPeer::RNE, $this->user->getRne());
    $c->add(RessourcePeer::UTILISATEUR_ID, $this->user->getId());
    $this->_arrayTexte = JCompetenceRessourcesPeer::doSelectJoinRessource($c);

  } // lier()


  public function fichier(){

    if ($this->_params['info'] == 'ressource' AND $this->_requete->isGet() === true){

      # On cherche la ressource pour vrifier que l'_id et l'adresse sont conformes
      $test = RessourcePeer::retrieveByPK($_GET['_id']);

      if (substr($test->getAdresse(), 0, -4) == $_GET['r']){
        if (file_exists('app/ressources/'.$test->getAdresse())){
          # On envoie le fichier au client
          header("content-type: application/octet-stream");
          // seulement pour application/octet-stream !
          header("Content-Disposition: attachment; filename=fichier".substr($test->getAdresse(), -4));
          flush(); // Envoie le buffer

          readfile('app/ressources/'.$test->getAdresse());

          $this->redirect_to(array('action'=>'creer', 'info'=>'-'));
          exit();
        }else{
          $this->setErreurMessage('Ce fichier n\existe plus : '.$test->getAdresse());
          $this->redirect_to(array('action'=>'creer', 'info'=>'erreur'));
          exit();
        }
      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // fichier()

  /**
   * Voir les bilans de tous les lves de la classe dont l'utilisateur est PP
   */
  public function eleves(){

    $c = new Criteria();
    $c->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->user->getId());
    $this->liste_classe = JProfesseurClassesPeer::doSelectJoinClasse($c);

  } // eleves()

  public function ajaxEleves(){

    if ($this->_requete->isPost() === true){

      $eleves = UtilisateurPeer::listeElevesCetteCLasse($this->_requete->_id);

      foreach ($eleves as $eleve) {
        $url = '../ajaxBilanEleve/'.$eleve->getId();
        echo '
        <br />
        <span class="lien" onclick="ajaxUpdater(\'aff_bilans\', \'bilan\', \''.$eleve->getId().'\', \''.$url.'\');">
          ' . $eleve->getNom(). ' ' . $eleve->getPrenom().'
        </span>';
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

    exit();// ajax

  } // ajaxEleves()

  public function ajaxBilanEleve(){
    $eleve = UtilisateurPeer::retrieveByPK($this->_requete->_id);

    if (empty ($eleve)){
      echo 'Cet &eacute;l&egrave;ve n\'existe pas !';
      exit();
    }else{
      echo $eleve->GetPrenom() . ' ' . $eleve->getNom() . '('.$eleve->getClasse()->getNom().')<br />';
    }

    # @TODO : on pourrait lister les contrles de ce professeur et n'appeler que les rsultats de ses contrles
    $controles = $this->user->getTabControlesDuProf();

    $c = new Criteria();
    $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_requete->_id);
    $c->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
    $c->add(JControleResultatPeer::CONTROLE_ID, $controles, Criteria::IN);
    $c->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);
    $liste = JControleResultatPeer::doSelectJoinCompetence($c);

    $couleurs = ValidationNiveauPeer::listeNiveauxValidation('color'); // pour savoir quelle est la couleur de chaque lettre
    $niveau   = ValidationNiveauPeer::listeNiveauxValidation('niveau'); // pour savoir  quel chiffre est associ chaque lettre

    $marqueur   = false; // toujours ce marqueur pour l'affichage
    $nbre_eval  = 0;
    $total      = array();
    $couleurs[0]= '';

    echo '
    <table class="table">';

    foreach ($liste as $join) {

      if ($join->getCompetenceId() != $marqueur){

        if ($marqueur !== false){
          # On peut proposer une "moyenne"
          echo '
        <td class="lig1">--</td>
        <td title="Moyenne calcul&eacute;e automatiquement par GEC" class="black font15" style="border:2px solid black;background-color:'.$couleurs[ValidationNiveauPeer::calculeMoyenne($nbre_eval, $total)].';">
          '.ValidationNiveauPeer::calculeMoyenne($nbre_eval, $total).'
        </td>';
          $nbre_eval  = 0;
          $total      = array();
          echo '</tr>';
        }
        echo '
      <tr>
        <td>'.$join->GetCompetence()->getNomlong() . '</td>
        ';
      }
      echo '<td title="Contr&ocirc;le : - '.$join->getControle()->getNomcourt().' - " style="background-color:'.$couleurs[$join->getResultat()].'">' . $join->getResultat() . '</td>';
      if ($join->getResultat() != 'a'){
        ++$nbre_eval;
      }
      $total[] = $niveau[$join->getResultat()];

      $marqueur = $join->getCompetenceId();
    }

    echo '
        <td>--</td>
        <td title="Moyenne calcul&eacute;e automatiquement par GEC" class="black font15" style="border:2px solid black;background-color:'.$couleurs[ValidationNiveauPeer::calculeMoyenne($nbre_eval, $total)].';">
          '.ValidationNiveauPeer::calculeMoyenne($nbre_eval, $total).'
        </td>
      </tr>
    </table>';

    exit(); // ajax
  } // ajaxBilanEleve()

  /**
   * Permet  un lve de lister les ressources disponibles pour un lot de comptences autour d'une cptce du socle
   */
  public function eleve(){

    $this->_layout = 'eleve';

    # On liste les ressources diponibles pour la comptence du socle appele et toutes les comptences drives
    $c = new Criteria();
    $c->add(CompetencePeer::RNE, array('all', $this->user->getRne()), Criteria::IN);
    $c->setDistinct();
    $criter1 = $c->getNewCriterion(CompetencePeer::ID, $this->_params['info'], Criteria::EQUAL);
    $criter2 = $c->getNewCriterion(CompetencePeer::COMPETENCE_ID, $this->_params['info'], Criteria::EQUAL);
    $criter1->addOr($criter2);
    $c->add($criter1);
    $c->addJoin(CompetencePeer::ID, JCompetenceRessourcesPeer::COMPETENCE_ID);
    $c->addAscendingOrderByColumn(JCompetenceRessourcesPeer::MATIERE_ID);
    $liste = CompetencePeer::doSelect($c);

    $this->_arrayTexte = $liste;

  }

}
?>