<?php
/**
 * @version $Id: settingsControleur.php 5 2009-10-25 18:25:17Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * You should have received a copy of the GNU General Public License
 * along with superGepi.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/**
 * Le settingsControleur permet de grer tous les rglages de l'application
 *
 * @author jjocal
 */
class settingsControleur extends applicationControleur{

  public $_titre = 'Les r&eacute;glages de l\'application';

  public function index(){

    $formulaire = new formulaireHtml(array('name'=>'ajouterSetting', 'forme'=>'p', 'action'=>'ajouter'), $this->_params);
    $formulaire->addInput(array('name'=>'nom', 'label'=>'Nom du r&eacute;glage : '));
    $formulaire->addInput(array('name'=>'valeur', 'label'=>'Valeur de ce r&eacute;glage : '));
    if ($this->user->getRoleId() == 5){
      $formulaire->addSelect(array('name'=>'rne', 'label'=>'Quel &eacute;tablissement ?'), etablissementPeer::listeetablissementsforselect());
    }
    $formulaire->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer le r&eacute;glage'));

    $this->form = $formulaire;

    # Liste des settings dj enregistrs
    $cr = new Criteria();
    if ($this->user->getRoleId() != 5){
      $cr->add(SettingPeer::RNE, $this->user->getRne());
    }
    $cr->addAscendingOrderByColumn(SettingPeer::NOM);
    $this->_arrayTexte = SettingPeer::doSelect($cr);

  }

  public function ajouter(){

    if ($this->_requete->isPost() === true){
      $newreg = new Setting();
      $newreg->setNom(htmlentities($this->_requete->ajouterSetting["nom"]));
      $newreg->setValeur(htmlentities($this->_requete->ajouterSetting["valeur"]));
      if ($this->user->getRoleId() != 5){
        $newreg->setRne($this->user->getRne());
      }else{
        $newreg->setRne($this->_requete->ajouterSetting['rne']);
      }

      if ($newreg->save()){
        $this->redirect_to(array('action'=>'index', 'info'=>'enregistre'));
      }else{
        $_SESSION["erreurMsg"] = 'Impossible d\'enregistrer ce nouveau r&eacute;glage !';
        $this->redirect_to(array('action'=>'index', 'info'=>'bad'));
      }

    }else{
      $this->dehorsUtilisateur('', 'settings', 'ajouter', $this->user->getId());
    }
    

  }

  public function effacer(){

    if ($this->_requete->isGet() AND $_GET['r'] == 'e'){
      // On peut effacer cet enregistrement
      $eff = SettingPeer::doDelete($this->_params["info"]);
    }
    $this->redirect_to(array('action'=>'index', 'info'=>'efface'));

  }

  public function validation(){

    $this->_aideMessage = '<p class="red bold">Seul le superadmin peut ajouter ou supprimer des niveaux de validation !</p>';

    $formulaire = new formulaireHtml(array('name'=>'ajouterValidation', 'action'=>'ajouterValidation', 'forme'=>'p'), $this->_params);
    $formulaire->addInput(array('name'=>'lettre', 'title'=>'Saisir la lettre en minuscule', 'label'=>'Lettre de validation : '));
    $formulaire->addInput(array('name'=>'texte', 'title'=>'Texte de validation', 'label'=>'Texte de validation : '));
    $formulaire->addInput(array('name'=>'couleur', 'title'=>'Saisir le code hexad&eacute;cimal avec le #', 'label'=>'Couleur de validation : '));
    $formulaire->addInput(array('name'=>'niveau', 'size'=>'2', 'title'=>'De "non maitris&eacute;e"  "maitris&eacute;e", de 1  plus de 1.', 'label'=>'Niveau de validation : '));
    $formulaire->addInput(array('type'=>'submit', 'name'=>'ajouter', 'value'=>'Ajouter ce niveau de validation'));

    $this->form = $formulaire;

    $cr = new Criteria();
    $cr->add(ValidationNiveauPeer::RNE, $this->user->getRne());
    $cr->addAscendingOrderByColumn(ValidationNiveauPeer::NIVEAU);
    $this->_arrayTexte = ValidationNiveauPeer::doSelect($cr);

  }

  public function ajouterValidation(){

    if ($this->_requete->isPost() === true){

      # Quelques vrifications sur les champs vides
      if ($this->_requete->ajouterValidation['lettre'] == '' OR $this->_requete->ajouterValidation['texte'] == '' OR $this->_requete->ajouterValidation['couleur'] == ''){
        $_SESSION['erreurMsg'] = 'Il faut renseigner tous les champs du formulaire !';
        $this->redirect_to(array('action'=>'validation', 'info'=>'erreur'));
        exit();
      }

      $new = new ValidationNiveau();
      $lettre = $this->_requete->ajouterValidation['lettre'];
      $new->setLettre(strtolower($lettre[0])); // on ne conserve que la premire lettre en minuscule
      $new->setTexte(htmlentities($this->_requete->ajouterValidation['texte']));
      $new->setCouleur(substr($this->_requete->ajouterValidation['couleur'], 0, 7));
      $new->setNiveau((int)$this->_requete->ajouterValidation['niveau']);
      $new->setRne($this->user->getRne());

      if ($new->save()){
        $this->redirect_to(array('action'=>'validation', 'info'=>'enregistre'));
        exit();
      }else{
        $_SESSION["erreurMsg"] = 'Impossible d\'enregistrer ce niveau de validation !';
        $this->redirect_to(array('action'=>'validation', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // ajouterValidation()

  public function effacerValidation(){

    if ($this->_requete->isGet() === true AND $_GET['e'] == 'r'){

      if (ValidationNiveauPeer::doDelete($this->_params['info'])){
        $this->redirect_to(array('action'=>'validation', 'info'=>'efface'));
        exit();
      }else{
        $_SESSION['erreurMsg'] = 'Impossible d\'effacer ce niveau de validation !';
        $this->redirect_to(array('action'=>'validation', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  }

  /**
   * Gestion des priodes de l'application (trimestre, semestre,...)
   */
  public function periodes(){

    $form = new formulaireHtml(array('name'=>'ajouterPeriode', 'forme'=>'p', 'action'=>'ajouterPeriode'), $this->_params);
    $form->addInput(array('name'=>'nom', 'label'=>'Nom de la p&eacute;riode :', 'title'=>'Utilisez un nom explicite pour d&eacute;finir la p&eacute;riode !'));
    $form->addInput(array('name'=>'debut', 'label'=>'D&eacute;but de la p&eacute;riode : ', 'title'=>'Sous la forme JJ/MM/YYYY'));
    $form->addInput(array('name'=>'fin', 'label'=>'Fin de la p&eacute;riode : ', 'title'=>'Sous la forme JJ/MM/YYYY'));
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

    $c = new Criteria();
    $c->add(PeriodePeer::RNE, $this->user->getRne());
    $c->addAscendingOrderByColumn(PeriodePeer::DEBUT);
    $this->_arrayTexte = PeriodePeer::doSelect($c);

  } // periodes

  public function ajouterPeriode(){
    if ($this->_requete->isPost() === true){
      # On vrifie si le nom est saisi
      if ($this->_requete->ajouterPeriode['nom'] == ''){
        $this->setErreurMessage('Il faut saisir un nom  la p&eacute;riode !');
        $this->redirect_to(array('action'=>'periodes', 'info'=>'erreur'));
        exit();
      }
      # On vrifie que les dates aient le bon format
      $deb = explode("/", $this->_requete->ajouterPeriode['debut']);
      $fin = explode("/", $this->_requete->ajouterPeriode['fin']);
      if (count($deb) != 3 OR count($fin) != 3){
        $this->setErreurMessage('Les dates doivent conserver la forme JJ/MM/YYYY, exemple : 02/09/2009 pour le 2 septembre 2009');
        $this->redirect_to(array('action'=>'periodes', 'info'=>'erreur'));
        exit();
      }
      # On peut alors enregistrer la priode
      $periode = new Periode();
      $periode->setNom(htmlentities($this->_requete->ajouterPeriode['nom']));
      $periode->setDebut(mktime(2, 0, 0, $deb[1], $deb[0], $deb[2]));
      $periode->setFin(mktime(23, 59, 0, $fin[1], $fin[0], $fin[2]));
      $periode->setRne($this->user->getRne());
      if ($periode->save()){
        $this->setMessage('La p&eacute;riode est enregistr&eacute;e !');
        $this->redirect_to(array('action'=>'periodes', 'info'=>'enregistre'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\enregistrer cette p&eacute;riode !');
        $this->redirect_to(array('action'=>'periodes', 'info'=>'erreur'));
        exit();
      }
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }
  } // ajouterPeriode()

  public function effacerPeriode(){

    if ($this->_params['info'] != '' AND is_numeric($this->_params['info'])){

      # Quelques tests
      $c = new Criteria();
      $c->add(PeriodePeer::RNE, $this->user->getRne());
      $c->add(PeriodePeer::ID, $this->_params['info']);
      $test = PeriodePeer::doSelect($c);

      if (!empty ($test) AND count($test) == 1){
        $test[0]->delete();
        $this->setMessage('P&eacute;riode supprim&eacute;e !');
        $this->redirect_to(array('action'=>'periodes', 'info'=>'efface'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // effacerPeriode()

}
?>
