<?php
/**
 * @version $Id$
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
require 'libexterne/pdf/fpdf.php';
class crbfpdf extends FPDF{

  /**
   * Il est possible de passer en paysage (L), d'utiliser d'autres formats de page (comme A3 et A5) ainsi que d'autres units de mesure (pt, cm, in).
   *
   * @param string $orientation P pour portrait et L pour paysage (P par dfaut)
   * @param string $unit pt, cm, in (mm par dfaut);
   * @param string $format A3, A4, 15 (A4 par dfaut)
   */
  public function  __construct($orientation='P', $unit='mm', $format='A4') {
    parent::FPDF($orientation, $unit, $format);
  }

  public function header(){

  }

  public function footer(){

    # On rcupre les informations de l'tablissement
    $etab_user = etablissementPeer::retrieveByPK($_SESSION['user']->getRne());
    if (empty ($etab_user)){
      $aff_etab = '';
    }else{
      $aff_etab = html_entity_decode($etab_user->getNom()) . ' de ' . html_entity_decode($etab_user->getCommune());
    }

    //Positionnement  1,5 cm du bas
    $this->SetY(-15);
    $this->SetFont('Arial', 'I', 8);
    $this->Cell(80, 8, $aff_etab, 0, 0);
    $this->Cell(0, 8, 'Page '.$this->PageNo().'/{nb} - (c) '.date('Y').' GEC v'.CRBVERSION, 0, 0, 'R');

  }

}

?>
