<?php

require 'competencesrb/om/BaseClassePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'classes' table.
 *
 * liste des classes
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class ClassePeer extends BaseClassePeer {

  /**
   * Mthode qui teste si le nom de cette classe existe, la cre le cas chant et renvoie l'id de la classe de l'lve
   *
   * @param string $nomClasse le nom de la classe
   * @return integer id de cette classe
   */
  public static function verifierClasseEtCreer($nomClasse, utilisateur $user){

    $c = new Criteria();
    $c->add(self::NOM, htmlentities($nomClasse));
    $c->add(self::RNE, $user->getRne());
    $test = self::doSelect($c);

    if (empty ($test)){
      # Si c'est null, on envoie 0
      if ($nomClasse == ''){
        return "0";
      }

      // On cre la classe
      $_classe = new Classe();
      $_classe->setNom(htmlentities($nomClasse));
      $_classe->setNomlong(htmlentities($nomClasse));
      $_classe->setRne($user->getRne());
      $_classe->save();

      return $_classe->getId();
    }else{
      return $test[0]->getId();
    }

  } // verifierClasseEtCreer()

  public static function listeClassesCeProfesseur($prof_id){
    $c = new Criteria();
    $c->add(JProfesseurClassesPeer::PROFESSEUR_ID, $prof_id);
    $liste = JProfesseurClassesPeer::doSelect($c);

    $tab = array();
    foreach ($liste as $JClasse){
      $tab[] = $JClasse->getClasseId();
    }
    return $tab;
  }

  /**
   * Liste des classes sous la forme d'un array des classe_id
   * 
   * @param object Utilisateur
   */
  public function listeClassesId(utilisateur $user){
    $c = new Criteria();
    $c->add(ClassePeer::RNE, $user->getRne());
    $liste = ClassePeer::doSelect($c);

    $tab = array();
    foreach ($liste as $join){
      $tab[] = $join->getId();
    }

    return $tab;

  } // listeClassesId()

} // ClassePeer
