<?php

require 'competencesrb/om/BaseJCompetenceVisiblePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'competence_visible' table.
 *
 * Permet a un etablissement de rendre invisible certaines competences
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class JCompetenceVisiblePeer extends BaseJCompetenceVisiblePeer {

  /**
   * Renvoie un tableau des comptences du socle qui sont caches par l'admin pour cet tablissement
   *
   * @param string $rne Le RNE de l'tablissement
   * @return array Tableau des competence_id
   */
  public static function socleCacheRne($rne){
    $cr = new Criteria();
    $cr->add(JCompetenceVisiblePeer::RNE, $rne);
    $cachee = JCompetenceVisiblePeer::doSelect($cr);
    $tab = array();
    foreach ($cachee as $socle) {
      $tab[] = $socle->getCompetenceId();
    }
    return $tab;
  }

} // JCompetenceVisiblePeer
