<?php

require 'competencesrb/om/BaseMatierePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'matieres' table.
 *
 * Liste des matieres
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class MatierePeer extends BaseMatierePeer {

  /**
   * Mise en forme d'un tableau php $tab[id] = nomlong; pour le select du formulaire
   *
   * @return array tab[id] = nomlong
   */
  public static function listeMatieresForSelect(){

    $criteria = new Criteria();
    $criteria->addAscendingOrderByColumn(MatierePeer::NOMLONG);
    $liste = MatierePeer::doSelect($criteria);

    $tab = array();
      $tab[0] = ' -- Liste des mati&egrave;res -- ';
    foreach ($liste as $matiere) {
      $tab[$matiere->getId()] = $matiere->getNomlong();
    }

    return $tab;

  } // listeMatieresForSelect()

  public static function verifierMatiereEtCreer($nomMatiere, $user){
    if ($nomMatiere == ''){
      return "0";
    }
    # On vrifie si cette matire existe
    $c = new Criteria();
    $c->add(MatierePeer::NOMCOURT, htmlentities($nomMatiere));
    $test = MatierePeer::doSelect($c);

    if (empty ($test)){
      # On cre la matire
      $matiere = new Matiere();
      $matiere->setNomcourt(htmlentities($nomMatiere));
      $matiere->setNomlong(htmlentities($nomMatiere));
      $matiere->save();

      return $matiere->getId();
    }else{
      return $test[0]->getId();
    }

  } // verifierMatiereEtCreer()

} // MatierePeer
