<?php

require 'competencesrb/om/BaseRessourcePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'ressources' table.
 *
 * Liste des ressources disponibles
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class RessourcePeer extends BaseRessourcePeer {

  /**
   * Renvoie une liste des ressources disponibles sous la forme $tab[ressource_id] = nom ressource;
   *
   * @param object $user l'objet utilisateurs
   * @return array tableau des ressources 
   */
  public static function listeRessourcesForSelect(Utilisateur $user){

    $c = new Criteria();
    $c->add(RessourcePeer::RNE, $user->getRne());
    $c->add(RessourcePeer::UTILISATEUR_ID, $user->getId());
    $liste = RessourcePeer::doSelect($c);

    $tab = array();
    $tab[0] = ' -- Liste des ressources -- ';
    if (! empty ($liste)){
      foreach ($liste as $ress) {
        $tab[$ress->getId()] = $ress->getDesignation();
      }
    }

    return $tab;

  }

} // RessourcePeer
