<?php

require 'competencesrb/om/BaseUtilisateur.php';


/**
 * Skeleton subclass for representing a row from the 'utilisateurs' table.
 *
 * utilisateurs
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class Utilisateur extends BaseUtilisateur {

	/**
	 * Initializes internal state of Utilisateur object.
	 * @see        parent::__construct()
	 */
	public function __construct()
	{
		// Make sure that parent constructor is always invoked, since that
		// is where any default values for this object are set.
		parent::__construct();
	}

  /**
   * Teste si le login est unique et enregistre l'utilisateur si c'est le cas
   */
  public function isLoginUniqueAndSave(){

    $c = new Criteria();
    $c->add(UtilisateurPeer::LOGIN, $this->getLogin(), Criteria::EQUAL);
    $test = UtilisateurPeer::doSelect($c);

    if (!empty ($test)){
      return false;
    }else{
      $this->save();
    }

  }
  /**
   * Renvoie la liste des domaines de comptences prfrs de l'utilisateur
   *
   * @return array $tab[] = $valeur
   */
  public function getDomainesDeCetUtilisateur(){

    $cr = new Criteria();
    $cr->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->getId(), Criteria::EQUAL);
    $rep = JCompetencegrpUtilisateurPeer::doSelect($cr);

    if (empty ($rep)){
      return $rep;
    }else{
      $tab = array ();
      foreach ($rep as $pref) {
        $tab[] = $pref->getCptcegrpId();
      }
      return $tab;
    }
  } // getDomainesDeCetUtilisateur()

  /**
   * Renvoie un tableau des id des contrles de ce professeur
   *
   * @param integer $debut dbut en timestamp UNIX
   * @param integer $fin fin en timestamp UNIX
   * @return array id des contrles
   */
  public function getTabControlesDuProf($debut = NULL, $fin = NULL){

    $c = new Criteria();
    $c->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->getId());
    if (!is_null($debut)){
      $c->add(ControlePeer::CREATED_ON, $debut, Criteria::GREATER_EQUAL);
    }
    if (!is_null($fin)){
      $c->add(ControlePeer::CREATED_ON, $fin, Criteria::LESS_EQUAL);
    }
    $liste = JControlePossesseurPeer::doSelect($c);
    $tab = array();
    foreach ($liste as $join){
      $tab[] = $join->getControleId();
    }
    return $tab;

  } // getTabControlesDuProf()

} // Utilisateur
