<?php

require 'competencesrb/om/BaserolePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'roles' table.
 *
 * Liste des roles possibles pour les utilisateurs
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class rolePeer extends BaserolePeer {

  /**
   * Renvoie un tableau des rles adapt  l'affichage d'un select de formulaire html
   *
   * @return array rles
   */
  public static function listeRolesForSelect(){

    $c = new Criteria();
    $c->addAscendingOrderByColumn(rolePeer::NOM);
    $liste = rolePeer::doSelect($c);
    $retour = array();

    if (!empty ($liste)){
      foreach ($liste as $role) {
        $retour[$role->getId()] = $role->getNom();
      }
    }
    return $retour;
  }

  /**
   * Renvoie l'id du role dont le nom est pass en paramtre
   *
   * @param string $name Nom du rle
   * @return integer Id du rle demand
   */
  public static function getIdByName($name){

    $c = new Criteria();
    $c->add(rolePeer::NOM, $name);
    $test = rolePeer::doSelectOne($c);

    if (!empty ($test)){
      return $test->getId();
    }else{
      Die('Ce rle n\'est pas disponible : '.$name);
    }

  } // getIdByName($name)

} // rolePeer
