<?php

/**
 * Base class that represents a row from the 'utilisateurs' table.
 *
 * utilisateurs
 *
 * @package    competencesrb.om
 */
abstract class BaseUtilisateur extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        UtilisateurPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the login field.
	 * @var        string
	 */
	protected $login;

	/**
	 * The value for the rne field.
	 * @var        string
	 */
	protected $rne;

	/**
	 * The value for the nom field.
	 * @var        string
	 */
	protected $nom;

	/**
	 * The value for the prenom field.
	 * @var        string
	 */
	protected $prenom;

	/**
	 * The value for the civilite field.
	 * @var        string
	 */
	protected $civilite;

	/**
	 * The value for the naissance field.
	 * @var        int
	 */
	protected $naissance;

	/**
	 * The value for the password field.
	 * @var        string
	 */
	protected $password;

	/**
	 * The value for the email field.
	 * @var        string
	 */
	protected $email;

	/**
	 * The value for the role_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $role_id;

	/**
	 * The value for the matiere_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $matiere_id;

	/**
	 * The value for the classe_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $classe_id;

	/**
	 * The value for the sso field.
	 * Note: this column has a database default value of: 'n'
	 * @var        string
	 */
	protected $sso;

	/**
	 * @var        etablissement
	 */
	protected $aetablissement;

	/**
	 * @var        role
	 */
	protected $arole;

	/**
	 * @var        Matiere
	 */
	protected $aMatiere;

	/**
	 * @var        Classe
	 */
	protected $aClasse;

	/**
	 * @var        array JProfesseurClasses[] Collection to store aggregation of JProfesseurClasses objects.
	 */
	protected $collJProfesseurClassess;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJProfesseurClassess.
	 */
	private $lastJProfesseurClassesCriteria = null;

	/**
	 * @var        array JProfesseurPrincipalClasses[] Collection to store aggregation of JProfesseurPrincipalClasses objects.
	 */
	protected $collJProfesseurPrincipalClassess;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJProfesseurPrincipalClassess.
	 */
	private $lastJProfesseurPrincipalClassesCriteria = null;

	/**
	 * @var        array Log[] Collection to store aggregation of Log objects.
	 */
	protected $collLogs;

	/**
	 * @var        Criteria The criteria used to select the current contents of collLogs.
	 */
	private $lastLogCriteria = null;

	/**
	 * @var        array Question[] Collection to store aggregation of Question objects.
	 */
	protected $collQuestions;

	/**
	 * @var        Criteria The criteria used to select the current contents of collQuestions.
	 */
	private $lastQuestionCriteria = null;

	/**
	 * @var        array ReponseQuestion[] Collection to store aggregation of ReponseQuestion objects.
	 */
	protected $collReponseQuestions;

	/**
	 * @var        Criteria The criteria used to select the current contents of collReponseQuestions.
	 */
	private $lastReponseQuestionCriteria = null;

	/**
	 * @var        array Competence[] Collection to store aggregation of Competence objects.
	 */
	protected $collCompetences;

	/**
	 * @var        Criteria The criteria used to select the current contents of collCompetences.
	 */
	private $lastCompetenceCriteria = null;

	/**
	 * @var        array JCompetencesProfesseurs[] Collection to store aggregation of JCompetencesProfesseurs objects.
	 */
	protected $collJCompetencesProfesseurss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJCompetencesProfesseurss.
	 */
	private $lastJCompetencesProfesseursCriteria = null;

	/**
	 * @var        array JCompetencegrpUtilisateur[] Collection to store aggregation of JCompetencegrpUtilisateur objects.
	 */
	protected $collJCompetencegrpUtilisateurs;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJCompetencegrpUtilisateurs.
	 */
	private $lastJCompetencegrpUtilisateurCriteria = null;

	/**
	 * @var        array Grille[] Collection to store aggregation of Grille objects.
	 */
	protected $collGrilles;

	/**
	 * @var        Criteria The criteria used to select the current contents of collGrilles.
	 */
	private $lastGrilleCriteria = null;

	/**
	 * @var        array JGrilleUtilisateur[] Collection to store aggregation of JGrilleUtilisateur objects.
	 */
	protected $collJGrilleUtilisateurs;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJGrilleUtilisateurs.
	 */
	private $lastJGrilleUtilisateurCriteria = null;

	/**
	 * @var        array JControlePossesseur[] Collection to store aggregation of JControlePossesseur objects.
	 */
	protected $collJControlePossesseurs;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJControlePossesseurs.
	 */
	private $lastJControlePossesseurCriteria = null;

	/**
	 * @var        array JControleResultat[] Collection to store aggregation of JControleResultat objects.
	 */
	protected $collJControleResultats;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJControleResultats.
	 */
	private $lastJControleResultatCriteria = null;

	/**
	 * @var        array JGroupePossesseur[] Collection to store aggregation of JGroupePossesseur objects.
	 */
	protected $collJGroupePossesseurs;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJGroupePossesseurs.
	 */
	private $lastJGroupePossesseurCriteria = null;

	/**
	 * @var        array JGroupeEleve[] Collection to store aggregation of JGroupeEleve objects.
	 */
	protected $collJGroupeEleves;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJGroupeEleves.
	 */
	private $lastJGroupeEleveCriteria = null;

	/**
	 * @var        array Bilan[] Collection to store aggregation of Bilan objects.
	 */
	protected $collBilansRelatedByProfesseurId;

	/**
	 * @var        Criteria The criteria used to select the current contents of collBilansRelatedByProfesseurId.
	 */
	private $lastBilanRelatedByProfesseurIdCriteria = null;

	/**
	 * @var        array Bilan[] Collection to store aggregation of Bilan objects.
	 */
	protected $collBilansRelatedByEleveId;

	/**
	 * @var        Criteria The criteria used to select the current contents of collBilansRelatedByEleveId.
	 */
	private $lastBilanRelatedByEleveIdCriteria = null;

	/**
	 * @var        array Appreciation[] Collection to store aggregation of Appreciation objects.
	 */
	protected $collAppreciationsRelatedByProfesseurId;

	/**
	 * @var        Criteria The criteria used to select the current contents of collAppreciationsRelatedByProfesseurId.
	 */
	private $lastAppreciationRelatedByProfesseurIdCriteria = null;

	/**
	 * @var        array Appreciation[] Collection to store aggregation of Appreciation objects.
	 */
	protected $collAppreciationsRelatedByEleveId;

	/**
	 * @var        Criteria The criteria used to select the current contents of collAppreciationsRelatedByEleveId.
	 */
	private $lastAppreciationRelatedByEleveIdCriteria = null;

	/**
	 * @var        array JDiscussionUtilisateurs[] Collection to store aggregation of JDiscussionUtilisateurs objects.
	 */
	protected $collJDiscussionUtilisateurss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJDiscussionUtilisateurss.
	 */
	private $lastJDiscussionUtilisateursCriteria = null;

	/**
	 * @var        array Echange[] Collection to store aggregation of Echange objects.
	 */
	protected $collEchanges;

	/**
	 * @var        Criteria The criteria used to select the current contents of collEchanges.
	 */
	private $lastEchangeCriteria = null;

	/**
	 * @var        array JDiscussionDocuments[] Collection to store aggregation of JDiscussionDocuments objects.
	 */
	protected $collJDiscussionDocumentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJDiscussionDocumentss.
	 */
	private $lastJDiscussionDocumentsCriteria = null;

	/**
	 * @var        array Ressource[] Collection to store aggregation of Ressource objects.
	 */
	protected $collRessources;

	/**
	 * @var        Criteria The criteria used to select the current contents of collRessources.
	 */
	private $lastRessourceCriteria = null;

	/**
	 * @var        array Attestation[] Collection to store aggregation of Attestation objects.
	 */
	protected $collAttestations;

	/**
	 * @var        Criteria The criteria used to select the current contents of collAttestations.
	 */
	private $lastAttestationCriteria = null;

	/**
	 * @var        array Exercice[] Collection to store aggregation of Exercice objects.
	 */
	protected $collExercices;

	/**
	 * @var        Criteria The criteria used to select the current contents of collExercices.
	 */
	private $lastExerciceCriteria = null;

	/**
	 * @var        array JExeReponse[] Collection to store aggregation of JExeReponse objects.
	 */
	protected $collJExeReponses;

	/**
	 * @var        Criteria The criteria used to select the current contents of collJExeReponses.
	 */
	private $lastJExeReponseCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseUtilisateur object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->role_id = 0;
		$this->matiere_id = 0;
		$this->classe_id = 0;
		$this->sso = 'n';
	}

	/**
	 * Get the [id] column value.
	 * cle primaire de la table utilisateurs
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [login] column value.
	 * Login de l'utilisateur
	 * @return     string
	 */
	public function getLogin()
	{
		return $this->login;
	}

	/**
	 * Get the [rne] column value.
	 * Etablissement de l'utilisateur
	 * @return     string
	 */
	public function getRne()
	{
		return $this->rne;
	}

	/**
	 * Get the [nom] column value.
	 * Nom de l'utilisateur
	 * @return     string
	 */
	public function getNom()
	{
		return $this->nom;
	}

	/**
	 * Get the [prenom] column value.
	 * Prenom de l'utilisateur
	 * @return     string
	 */
	public function getPrenom()
	{
		return $this->prenom;
	}

	/**
	 * Get the [civilite] column value.
	 * Civilite
	 * @return     string
	 */
	public function getCivilite()
	{
		return $this->civilite;
	}

	/**
	 * Get the [naissance] column value.
	 * Date de naissance en timestamp UNIX
	 * @return     int
	 */
	public function getNaissance()
	{
		return $this->naissance;
	}

	/**
	 * Get the [password] column value.
	 * Mot de passe
	 * @return     string
	 */
	public function getPassword()
	{
		return $this->password;
	}

	/**
	 * Get the [email] column value.
	 * Email de l'utilisateur
	 * @return     string
	 */
	public function getEmail()
	{
		return $this->email;
	}

	/**
	 * Get the [role_id] column value.
	 * cle etrangere du role de l'utilisateur
	 * @return     int
	 */
	public function getRoleId()
	{
		return $this->role_id;
	}

	/**
	 * Get the [matiere_id] column value.
	 * cle etrangere de la matiere du professeur, nulle si pas un professeur
	 * @return     int
	 */
	public function getMatiereId()
	{
		return $this->matiere_id;
	}

	/**
	 * Get the [classe_id] column value.
	 * cle etrangere de la classe, nulle si pas un eleve sauf PP
	 * @return     int
	 */
	public function getClasseId()
	{
		return $this->classe_id;
	}

	/**
	 * Get the [sso] column value.
	 * Si acces possible en sso
	 * @return     string
	 */
	public function getSso()
	{
		return $this->sso;
	}

	/**
	 * Set the value of [id] column.
	 * cle primaire de la table utilisateurs
	 * @param      int $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UtilisateurPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [login] column.
	 * Login de l'utilisateur
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setLogin($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->login !== $v) {
			$this->login = $v;
			$this->modifiedColumns[] = UtilisateurPeer::LOGIN;
		}

		return $this;
	} // setLogin()

	/**
	 * Set the value of [rne] column.
	 * Etablissement de l'utilisateur
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setRne($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->rne !== $v) {
			$this->rne = $v;
			$this->modifiedColumns[] = UtilisateurPeer::RNE;
		}

		if ($this->aetablissement !== null && $this->aetablissement->getRne() !== $v) {
			$this->aetablissement = null;
		}

		return $this;
	} // setRne()

	/**
	 * Set the value of [nom] column.
	 * Nom de l'utilisateur
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setNom($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nom !== $v) {
			$this->nom = $v;
			$this->modifiedColumns[] = UtilisateurPeer::NOM;
		}

		return $this;
	} // setNom()

	/**
	 * Set the value of [prenom] column.
	 * Prenom de l'utilisateur
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setPrenom($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->prenom !== $v) {
			$this->prenom = $v;
			$this->modifiedColumns[] = UtilisateurPeer::PRENOM;
		}

		return $this;
	} // setPrenom()

	/**
	 * Set the value of [civilite] column.
	 * Civilite
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setCivilite($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->civilite !== $v) {
			$this->civilite = $v;
			$this->modifiedColumns[] = UtilisateurPeer::CIVILITE;
		}

		return $this;
	} // setCivilite()

	/**
	 * Set the value of [naissance] column.
	 * Date de naissance en timestamp UNIX
	 * @param      int $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setNaissance($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->naissance !== $v) {
			$this->naissance = $v;
			$this->modifiedColumns[] = UtilisateurPeer::NAISSANCE;
		}

		return $this;
	} // setNaissance()

	/**
	 * Set the value of [password] column.
	 * Mot de passe
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setPassword($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->password !== $v) {
			$this->password = $v;
			$this->modifiedColumns[] = UtilisateurPeer::PASSWORD;
		}

		return $this;
	} // setPassword()

	/**
	 * Set the value of [email] column.
	 * Email de l'utilisateur
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = UtilisateurPeer::EMAIL;
		}

		return $this;
	} // setEmail()

	/**
	 * Set the value of [role_id] column.
	 * cle etrangere du role de l'utilisateur
	 * @param      int $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setRoleId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->role_id !== $v || $v === 0) {
			$this->role_id = $v;
			$this->modifiedColumns[] = UtilisateurPeer::ROLE_ID;
		}

		if ($this->arole !== null && $this->arole->getId() !== $v) {
			$this->arole = null;
		}

		return $this;
	} // setRoleId()

	/**
	 * Set the value of [matiere_id] column.
	 * cle etrangere de la matiere du professeur, nulle si pas un professeur
	 * @param      int $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setMatiereId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->matiere_id !== $v || $v === 0) {
			$this->matiere_id = $v;
			$this->modifiedColumns[] = UtilisateurPeer::MATIERE_ID;
		}

		if ($this->aMatiere !== null && $this->aMatiere->getId() !== $v) {
			$this->aMatiere = null;
		}

		return $this;
	} // setMatiereId()

	/**
	 * Set the value of [classe_id] column.
	 * cle etrangere de la classe, nulle si pas un eleve sauf PP
	 * @param      int $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setClasseId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->classe_id !== $v || $v === 0) {
			$this->classe_id = $v;
			$this->modifiedColumns[] = UtilisateurPeer::CLASSE_ID;
		}

		if ($this->aClasse !== null && $this->aClasse->getId() !== $v) {
			$this->aClasse = null;
		}

		return $this;
	} // setClasseId()

	/**
	 * Set the value of [sso] column.
	 * Si acces possible en sso
	 * @param      string $v new value
	 * @return     Utilisateur The current object (for fluent API support)
	 */
	public function setSso($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sso !== $v || $v === 'n') {
			$this->sso = $v;
			$this->modifiedColumns[] = UtilisateurPeer::SSO;
		}

		return $this;
	} // setSso()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(UtilisateurPeer::ROLE_ID,UtilisateurPeer::MATIERE_ID,UtilisateurPeer::CLASSE_ID,UtilisateurPeer::SSO))) {
				return false;
			}

			if ($this->role_id !== 0) {
				return false;
			}

			if ($this->matiere_id !== 0) {
				return false;
			}

			if ($this->classe_id !== 0) {
				return false;
			}

			if ($this->sso !== 'n') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->login = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->rne = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->nom = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->prenom = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->civilite = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->naissance = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->password = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->email = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->role_id = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->matiere_id = ($row[$startcol + 10] !== null) ? (int) $row[$startcol + 10] : null;
			$this->classe_id = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->sso = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 13; // 13 = UtilisateurPeer::NUM_COLUMNS - UtilisateurPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Utilisateur object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aetablissement !== null && $this->rne !== $this->aetablissement->getRne()) {
			$this->aetablissement = null;
		}
		if ($this->arole !== null && $this->role_id !== $this->arole->getId()) {
			$this->arole = null;
		}
		if ($this->aMatiere !== null && $this->matiere_id !== $this->aMatiere->getId()) {
			$this->aMatiere = null;
		}
		if ($this->aClasse !== null && $this->classe_id !== $this->aClasse->getId()) {
			$this->aClasse = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UtilisateurPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = UtilisateurPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aetablissement = null;
			$this->arole = null;
			$this->aMatiere = null;
			$this->aClasse = null;
			$this->collJProfesseurClassess = null;
			$this->lastJProfesseurClassesCriteria = null;

			$this->collJProfesseurPrincipalClassess = null;
			$this->lastJProfesseurPrincipalClassesCriteria = null;

			$this->collLogs = null;
			$this->lastLogCriteria = null;

			$this->collQuestions = null;
			$this->lastQuestionCriteria = null;

			$this->collReponseQuestions = null;
			$this->lastReponseQuestionCriteria = null;

			$this->collCompetences = null;
			$this->lastCompetenceCriteria = null;

			$this->collJCompetencesProfesseurss = null;
			$this->lastJCompetencesProfesseursCriteria = null;

			$this->collJCompetencegrpUtilisateurs = null;
			$this->lastJCompetencegrpUtilisateurCriteria = null;

			$this->collGrilles = null;
			$this->lastGrilleCriteria = null;

			$this->collJGrilleUtilisateurs = null;
			$this->lastJGrilleUtilisateurCriteria = null;

			$this->collJControlePossesseurs = null;
			$this->lastJControlePossesseurCriteria = null;

			$this->collJControleResultats = null;
			$this->lastJControleResultatCriteria = null;

			$this->collJGroupePossesseurs = null;
			$this->lastJGroupePossesseurCriteria = null;

			$this->collJGroupeEleves = null;
			$this->lastJGroupeEleveCriteria = null;

			$this->collBilansRelatedByProfesseurId = null;
			$this->lastBilanRelatedByProfesseurIdCriteria = null;

			$this->collBilansRelatedByEleveId = null;
			$this->lastBilanRelatedByEleveIdCriteria = null;

			$this->collAppreciationsRelatedByProfesseurId = null;
			$this->lastAppreciationRelatedByProfesseurIdCriteria = null;

			$this->collAppreciationsRelatedByEleveId = null;
			$this->lastAppreciationRelatedByEleveIdCriteria = null;

			$this->collJDiscussionUtilisateurss = null;
			$this->lastJDiscussionUtilisateursCriteria = null;

			$this->collEchanges = null;
			$this->lastEchangeCriteria = null;

			$this->collJDiscussionDocumentss = null;
			$this->lastJDiscussionDocumentsCriteria = null;

			$this->collRessources = null;
			$this->lastRessourceCriteria = null;

			$this->collAttestations = null;
			$this->lastAttestationCriteria = null;

			$this->collExercices = null;
			$this->lastExerciceCriteria = null;

			$this->collJExeReponses = null;
			$this->lastJExeReponseCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UtilisateurPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			UtilisateurPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UtilisateurPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			UtilisateurPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aetablissement !== null) {
				if ($this->aetablissement->isModified() || $this->aetablissement->isNew()) {
					$affectedRows += $this->aetablissement->save($con);
				}
				$this->setetablissement($this->aetablissement);
			}

			if ($this->arole !== null) {
				if ($this->arole->isModified() || $this->arole->isNew()) {
					$affectedRows += $this->arole->save($con);
				}
				$this->setrole($this->arole);
			}

			if ($this->aMatiere !== null) {
				if ($this->aMatiere->isModified() || $this->aMatiere->isNew()) {
					$affectedRows += $this->aMatiere->save($con);
				}
				$this->setMatiere($this->aMatiere);
			}

			if ($this->aClasse !== null) {
				if ($this->aClasse->isModified() || $this->aClasse->isNew()) {
					$affectedRows += $this->aClasse->save($con);
				}
				$this->setClasse($this->aClasse);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = UtilisateurPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UtilisateurPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UtilisateurPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collJProfesseurClassess !== null) {
				foreach ($this->collJProfesseurClassess as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJProfesseurPrincipalClassess !== null) {
				foreach ($this->collJProfesseurPrincipalClassess as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collLogs !== null) {
				foreach ($this->collLogs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collQuestions !== null) {
				foreach ($this->collQuestions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collReponseQuestions !== null) {
				foreach ($this->collReponseQuestions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCompetences !== null) {
				foreach ($this->collCompetences as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJCompetencesProfesseurss !== null) {
				foreach ($this->collJCompetencesProfesseurss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJCompetencegrpUtilisateurs !== null) {
				foreach ($this->collJCompetencegrpUtilisateurs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGrilles !== null) {
				foreach ($this->collGrilles as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJGrilleUtilisateurs !== null) {
				foreach ($this->collJGrilleUtilisateurs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJControlePossesseurs !== null) {
				foreach ($this->collJControlePossesseurs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJControleResultats !== null) {
				foreach ($this->collJControleResultats as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJGroupePossesseurs !== null) {
				foreach ($this->collJGroupePossesseurs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJGroupeEleves !== null) {
				foreach ($this->collJGroupeEleves as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collBilansRelatedByProfesseurId !== null) {
				foreach ($this->collBilansRelatedByProfesseurId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collBilansRelatedByEleveId !== null) {
				foreach ($this->collBilansRelatedByEleveId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collAppreciationsRelatedByProfesseurId !== null) {
				foreach ($this->collAppreciationsRelatedByProfesseurId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collAppreciationsRelatedByEleveId !== null) {
				foreach ($this->collAppreciationsRelatedByEleveId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJDiscussionUtilisateurss !== null) {
				foreach ($this->collJDiscussionUtilisateurss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collEchanges !== null) {
				foreach ($this->collEchanges as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJDiscussionDocumentss !== null) {
				foreach ($this->collJDiscussionDocumentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collRessources !== null) {
				foreach ($this->collRessources as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collAttestations !== null) {
				foreach ($this->collAttestations as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collExercices !== null) {
				foreach ($this->collExercices as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collJExeReponses !== null) {
				foreach ($this->collJExeReponses as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aetablissement !== null) {
				if (!$this->aetablissement->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aetablissement->getValidationFailures());
				}
			}

			if ($this->arole !== null) {
				if (!$this->arole->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->arole->getValidationFailures());
				}
			}

			if ($this->aMatiere !== null) {
				if (!$this->aMatiere->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMatiere->getValidationFailures());
				}
			}

			if ($this->aClasse !== null) {
				if (!$this->aClasse->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aClasse->getValidationFailures());
				}
			}


			if (($retval = UtilisateurPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collJProfesseurClassess !== null) {
					foreach ($this->collJProfesseurClassess as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJProfesseurPrincipalClassess !== null) {
					foreach ($this->collJProfesseurPrincipalClassess as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collLogs !== null) {
					foreach ($this->collLogs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collQuestions !== null) {
					foreach ($this->collQuestions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collReponseQuestions !== null) {
					foreach ($this->collReponseQuestions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCompetences !== null) {
					foreach ($this->collCompetences as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJCompetencesProfesseurss !== null) {
					foreach ($this->collJCompetencesProfesseurss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJCompetencegrpUtilisateurs !== null) {
					foreach ($this->collJCompetencegrpUtilisateurs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGrilles !== null) {
					foreach ($this->collGrilles as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJGrilleUtilisateurs !== null) {
					foreach ($this->collJGrilleUtilisateurs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJControlePossesseurs !== null) {
					foreach ($this->collJControlePossesseurs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJControleResultats !== null) {
					foreach ($this->collJControleResultats as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJGroupePossesseurs !== null) {
					foreach ($this->collJGroupePossesseurs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJGroupeEleves !== null) {
					foreach ($this->collJGroupeEleves as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collBilansRelatedByProfesseurId !== null) {
					foreach ($this->collBilansRelatedByProfesseurId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collBilansRelatedByEleveId !== null) {
					foreach ($this->collBilansRelatedByEleveId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collAppreciationsRelatedByProfesseurId !== null) {
					foreach ($this->collAppreciationsRelatedByProfesseurId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collAppreciationsRelatedByEleveId !== null) {
					foreach ($this->collAppreciationsRelatedByEleveId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJDiscussionUtilisateurss !== null) {
					foreach ($this->collJDiscussionUtilisateurss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collEchanges !== null) {
					foreach ($this->collEchanges as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJDiscussionDocumentss !== null) {
					foreach ($this->collJDiscussionDocumentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collRessources !== null) {
					foreach ($this->collRessources as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collAttestations !== null) {
					foreach ($this->collAttestations as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collExercices !== null) {
					foreach ($this->collExercices as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collJExeReponses !== null) {
					foreach ($this->collJExeReponses as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UtilisateurPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getLogin();
				break;
			case 2:
				return $this->getRne();
				break;
			case 3:
				return $this->getNom();
				break;
			case 4:
				return $this->getPrenom();
				break;
			case 5:
				return $this->getCivilite();
				break;
			case 6:
				return $this->getNaissance();
				break;
			case 7:
				return $this->getPassword();
				break;
			case 8:
				return $this->getEmail();
				break;
			case 9:
				return $this->getRoleId();
				break;
			case 10:
				return $this->getMatiereId();
				break;
			case 11:
				return $this->getClasseId();
				break;
			case 12:
				return $this->getSso();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = UtilisateurPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getLogin(),
			$keys[2] => $this->getRne(),
			$keys[3] => $this->getNom(),
			$keys[4] => $this->getPrenom(),
			$keys[5] => $this->getCivilite(),
			$keys[6] => $this->getNaissance(),
			$keys[7] => $this->getPassword(),
			$keys[8] => $this->getEmail(),
			$keys[9] => $this->getRoleId(),
			$keys[10] => $this->getMatiereId(),
			$keys[11] => $this->getClasseId(),
			$keys[12] => $this->getSso(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UtilisateurPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setLogin($value);
				break;
			case 2:
				$this->setRne($value);
				break;
			case 3:
				$this->setNom($value);
				break;
			case 4:
				$this->setPrenom($value);
				break;
			case 5:
				$this->setCivilite($value);
				break;
			case 6:
				$this->setNaissance($value);
				break;
			case 7:
				$this->setPassword($value);
				break;
			case 8:
				$this->setEmail($value);
				break;
			case 9:
				$this->setRoleId($value);
				break;
			case 10:
				$this->setMatiereId($value);
				break;
			case 11:
				$this->setClasseId($value);
				break;
			case 12:
				$this->setSso($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UtilisateurPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setLogin($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setRne($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNom($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setPrenom($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setCivilite($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setNaissance($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setPassword($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setEmail($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setRoleId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setMatiereId($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setClasseId($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setSso($arr[$keys[12]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);

		if ($this->isColumnModified(UtilisateurPeer::ID)) $criteria->add(UtilisateurPeer::ID, $this->id);
		if ($this->isColumnModified(UtilisateurPeer::LOGIN)) $criteria->add(UtilisateurPeer::LOGIN, $this->login);
		if ($this->isColumnModified(UtilisateurPeer::RNE)) $criteria->add(UtilisateurPeer::RNE, $this->rne);
		if ($this->isColumnModified(UtilisateurPeer::NOM)) $criteria->add(UtilisateurPeer::NOM, $this->nom);
		if ($this->isColumnModified(UtilisateurPeer::PRENOM)) $criteria->add(UtilisateurPeer::PRENOM, $this->prenom);
		if ($this->isColumnModified(UtilisateurPeer::CIVILITE)) $criteria->add(UtilisateurPeer::CIVILITE, $this->civilite);
		if ($this->isColumnModified(UtilisateurPeer::NAISSANCE)) $criteria->add(UtilisateurPeer::NAISSANCE, $this->naissance);
		if ($this->isColumnModified(UtilisateurPeer::PASSWORD)) $criteria->add(UtilisateurPeer::PASSWORD, $this->password);
		if ($this->isColumnModified(UtilisateurPeer::EMAIL)) $criteria->add(UtilisateurPeer::EMAIL, $this->email);
		if ($this->isColumnModified(UtilisateurPeer::ROLE_ID)) $criteria->add(UtilisateurPeer::ROLE_ID, $this->role_id);
		if ($this->isColumnModified(UtilisateurPeer::MATIERE_ID)) $criteria->add(UtilisateurPeer::MATIERE_ID, $this->matiere_id);
		if ($this->isColumnModified(UtilisateurPeer::CLASSE_ID)) $criteria->add(UtilisateurPeer::CLASSE_ID, $this->classe_id);
		if ($this->isColumnModified(UtilisateurPeer::SSO)) $criteria->add(UtilisateurPeer::SSO, $this->sso);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);

		$criteria->add(UtilisateurPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Utilisateur (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setLogin($this->login);

		$copyObj->setRne($this->rne);

		$copyObj->setNom($this->nom);

		$copyObj->setPrenom($this->prenom);

		$copyObj->setCivilite($this->civilite);

		$copyObj->setNaissance($this->naissance);

		$copyObj->setPassword($this->password);

		$copyObj->setEmail($this->email);

		$copyObj->setRoleId($this->role_id);

		$copyObj->setMatiereId($this->matiere_id);

		$copyObj->setClasseId($this->classe_id);

		$copyObj->setSso($this->sso);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getJProfesseurClassess() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJProfesseurClasses($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJProfesseurPrincipalClassess() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJProfesseurPrincipalClasses($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getLogs() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addLog($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getQuestions() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addQuestion($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getReponseQuestions() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addReponseQuestion($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getCompetences() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addCompetence($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJCompetencesProfesseurss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJCompetencesProfesseurs($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJCompetencegrpUtilisateurs() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJCompetencegrpUtilisateur($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGrilles() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addGrille($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJGrilleUtilisateurs() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJGrilleUtilisateur($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJControlePossesseurs() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJControlePossesseur($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJControleResultats() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJControleResultat($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJGroupePossesseurs() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJGroupePossesseur($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJGroupeEleves() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJGroupeEleve($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getBilansRelatedByProfesseurId() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addBilanRelatedByProfesseurId($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getBilansRelatedByEleveId() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addBilanRelatedByEleveId($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getAppreciationsRelatedByProfesseurId() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addAppreciationRelatedByProfesseurId($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getAppreciationsRelatedByEleveId() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addAppreciationRelatedByEleveId($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJDiscussionUtilisateurss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJDiscussionUtilisateurs($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getEchanges() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEchange($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJDiscussionDocumentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJDiscussionDocuments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getRessources() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addRessource($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getAttestations() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addAttestation($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getExercices() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addExercice($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getJExeReponses() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addJExeReponse($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Utilisateur Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     UtilisateurPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UtilisateurPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a etablissement object.
	 *
	 * @param      etablissement $v
	 * @return     Utilisateur The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setetablissement(etablissement $v = null)
	{
		if ($v === null) {
			$this->setRne(NULL);
		} else {
			$this->setRne($v->getRne());
		}

		$this->aetablissement = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the etablissement object, it will not be re-added.
		if ($v !== null) {
			$v->addUtilisateur($this);
		}

		return $this;
	}


	/**
	 * Get the associated etablissement object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     etablissement The associated etablissement object.
	 * @throws     PropelException
	 */
	public function getetablissement(PropelPDO $con = null)
	{
		if ($this->aetablissement === null && (($this->rne !== "" && $this->rne !== null))) {
			$this->aetablissement = etablissementPeer::retrieveByPK($this->rne, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aetablissement->addUtilisateurs($this);
			 */
		}
		return $this->aetablissement;
	}

	/**
	 * Declares an association between this object and a role object.
	 *
	 * @param      role $v
	 * @return     Utilisateur The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setrole(role $v = null)
	{
		if ($v === null) {
			$this->setRoleId(0);
		} else {
			$this->setRoleId($v->getId());
		}

		$this->arole = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the role object, it will not be re-added.
		if ($v !== null) {
			$v->addUtilisateur($this);
		}

		return $this;
	}


	/**
	 * Get the associated role object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     role The associated role object.
	 * @throws     PropelException
	 */
	public function getrole(PropelPDO $con = null)
	{
		if ($this->arole === null && ($this->role_id !== null)) {
			$this->arole = rolePeer::retrieveByPK($this->role_id, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->arole->addUtilisateurs($this);
			 */
		}
		return $this->arole;
	}

	/**
	 * Declares an association between this object and a Matiere object.
	 *
	 * @param      Matiere $v
	 * @return     Utilisateur The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setMatiere(Matiere $v = null)
	{
		if ($v === null) {
			$this->setMatiereId(0);
		} else {
			$this->setMatiereId($v->getId());
		}

		$this->aMatiere = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Matiere object, it will not be re-added.
		if ($v !== null) {
			$v->addUtilisateur($this);
		}

		return $this;
	}


	/**
	 * Get the associated Matiere object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Matiere The associated Matiere object.
	 * @throws     PropelException
	 */
	public function getMatiere(PropelPDO $con = null)
	{
		if ($this->aMatiere === null && ($this->matiere_id !== null)) {
			$this->aMatiere = MatierePeer::retrieveByPK($this->matiere_id, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aMatiere->addUtilisateurs($this);
			 */
		}
		return $this->aMatiere;
	}

	/**
	 * Declares an association between this object and a Classe object.
	 *
	 * @param      Classe $v
	 * @return     Utilisateur The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setClasse(Classe $v = null)
	{
		if ($v === null) {
			$this->setClasseId(0);
		} else {
			$this->setClasseId($v->getId());
		}

		$this->aClasse = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Classe object, it will not be re-added.
		if ($v !== null) {
			$v->addUtilisateur($this);
		}

		return $this;
	}


	/**
	 * Get the associated Classe object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Classe The associated Classe object.
	 * @throws     PropelException
	 */
	public function getClasse(PropelPDO $con = null)
	{
		if ($this->aClasse === null && ($this->classe_id !== null)) {
			$this->aClasse = ClassePeer::retrieveByPK($this->classe_id, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aClasse->addUtilisateurs($this);
			 */
		}
		return $this->aClasse;
	}

	/**
	 * Clears out the collJProfesseurClassess collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJProfesseurClassess()
	 */
	public function clearJProfesseurClassess()
	{
		$this->collJProfesseurClassess = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJProfesseurClassess collection (array).
	 *
	 * By default this just sets the collJProfesseurClassess collection to an empty array (like clearcollJProfesseurClassess());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJProfesseurClassess()
	{
		$this->collJProfesseurClassess = array();
	}

	/**
	 * Gets an array of JProfesseurClasses objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JProfesseurClassess from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JProfesseurClasses[]
	 * @throws     PropelException
	 */
	public function getJProfesseurClassess($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJProfesseurClassess === null) {
			if ($this->isNew()) {
			   $this->collJProfesseurClassess = array();
			} else {

				$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

				JProfesseurClassesPeer::addSelectColumns($criteria);
				$this->collJProfesseurClassess = JProfesseurClassesPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

				JProfesseurClassesPeer::addSelectColumns($criteria);
				if (!isset($this->lastJProfesseurClassesCriteria) || !$this->lastJProfesseurClassesCriteria->equals($criteria)) {
					$this->collJProfesseurClassess = JProfesseurClassesPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJProfesseurClassesCriteria = $criteria;
		return $this->collJProfesseurClassess;
	}

	/**
	 * Returns the number of related JProfesseurClasses objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JProfesseurClasses objects.
	 * @throws     PropelException
	 */
	public function countJProfesseurClassess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJProfesseurClassess === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

				$count = JProfesseurClassesPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastJProfesseurClassesCriteria) || !$this->lastJProfesseurClassesCriteria->equals($criteria)) {
					$count = JProfesseurClassesPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJProfesseurClassess);
				}
			} else {
				$count = count($this->collJProfesseurClassess);
			}
		}
		$this->lastJProfesseurClassesCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JProfesseurClasses object to this object
	 * through the JProfesseurClasses foreign key attribute.
	 *
	 * @param      JProfesseurClasses $l JProfesseurClasses
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJProfesseurClasses(JProfesseurClasses $l)
	{
		if ($this->collJProfesseurClassess === null) {
			$this->initJProfesseurClassess();
		}
		if (!in_array($l, $this->collJProfesseurClassess, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJProfesseurClassess, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JProfesseurClassess from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJProfesseurClassessJoinClasse($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJProfesseurClassess === null) {
			if ($this->isNew()) {
				$this->collJProfesseurClassess = array();
			} else {

				$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

				$this->collJProfesseurClassess = JProfesseurClassesPeer::doSelectJoinClasse($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastJProfesseurClassesCriteria) || !$this->lastJProfesseurClassesCriteria->equals($criteria)) {
				$this->collJProfesseurClassess = JProfesseurClassesPeer::doSelectJoinClasse($criteria, $con, $join_behavior);
			}
		}
		$this->lastJProfesseurClassesCriteria = $criteria;

		return $this->collJProfesseurClassess;
	}

	/**
	 * Clears out the collJProfesseurPrincipalClassess collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJProfesseurPrincipalClassess()
	 */
	public function clearJProfesseurPrincipalClassess()
	{
		$this->collJProfesseurPrincipalClassess = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJProfesseurPrincipalClassess collection (array).
	 *
	 * By default this just sets the collJProfesseurPrincipalClassess collection to an empty array (like clearcollJProfesseurPrincipalClassess());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJProfesseurPrincipalClassess()
	{
		$this->collJProfesseurPrincipalClassess = array();
	}

	/**
	 * Gets an array of JProfesseurPrincipalClasses objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JProfesseurPrincipalClassess from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JProfesseurPrincipalClasses[]
	 * @throws     PropelException
	 */
	public function getJProfesseurPrincipalClassess($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJProfesseurPrincipalClassess === null) {
			if ($this->isNew()) {
			   $this->collJProfesseurPrincipalClassess = array();
			} else {

				$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

				JProfesseurPrincipalClassesPeer::addSelectColumns($criteria);
				$this->collJProfesseurPrincipalClassess = JProfesseurPrincipalClassesPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

				JProfesseurPrincipalClassesPeer::addSelectColumns($criteria);
				if (!isset($this->lastJProfesseurPrincipalClassesCriteria) || !$this->lastJProfesseurPrincipalClassesCriteria->equals($criteria)) {
					$this->collJProfesseurPrincipalClassess = JProfesseurPrincipalClassesPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJProfesseurPrincipalClassesCriteria = $criteria;
		return $this->collJProfesseurPrincipalClassess;
	}

	/**
	 * Returns the number of related JProfesseurPrincipalClasses objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JProfesseurPrincipalClasses objects.
	 * @throws     PropelException
	 */
	public function countJProfesseurPrincipalClassess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJProfesseurPrincipalClassess === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

				$count = JProfesseurPrincipalClassesPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastJProfesseurPrincipalClassesCriteria) || !$this->lastJProfesseurPrincipalClassesCriteria->equals($criteria)) {
					$count = JProfesseurPrincipalClassesPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJProfesseurPrincipalClassess);
				}
			} else {
				$count = count($this->collJProfesseurPrincipalClassess);
			}
		}
		$this->lastJProfesseurPrincipalClassesCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JProfesseurPrincipalClasses object to this object
	 * through the JProfesseurPrincipalClasses foreign key attribute.
	 *
	 * @param      JProfesseurPrincipalClasses $l JProfesseurPrincipalClasses
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJProfesseurPrincipalClasses(JProfesseurPrincipalClasses $l)
	{
		if ($this->collJProfesseurPrincipalClassess === null) {
			$this->initJProfesseurPrincipalClassess();
		}
		if (!in_array($l, $this->collJProfesseurPrincipalClassess, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJProfesseurPrincipalClassess, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JProfesseurPrincipalClassess from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJProfesseurPrincipalClassessJoinClasse($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJProfesseurPrincipalClassess === null) {
			if ($this->isNew()) {
				$this->collJProfesseurPrincipalClassess = array();
			} else {

				$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

				$this->collJProfesseurPrincipalClassess = JProfesseurPrincipalClassesPeer::doSelectJoinClasse($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JProfesseurPrincipalClassesPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastJProfesseurPrincipalClassesCriteria) || !$this->lastJProfesseurPrincipalClassesCriteria->equals($criteria)) {
				$this->collJProfesseurPrincipalClassess = JProfesseurPrincipalClassesPeer::doSelectJoinClasse($criteria, $con, $join_behavior);
			}
		}
		$this->lastJProfesseurPrincipalClassesCriteria = $criteria;

		return $this->collJProfesseurPrincipalClassess;
	}

	/**
	 * Clears out the collLogs collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addLogs()
	 */
	public function clearLogs()
	{
		$this->collLogs = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collLogs collection (array).
	 *
	 * By default this just sets the collLogs collection to an empty array (like clearcollLogs());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initLogs()
	{
		$this->collLogs = array();
	}

	/**
	 * Gets an array of Log objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Logs from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Log[]
	 * @throws     PropelException
	 */
	public function getLogs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collLogs === null) {
			if ($this->isNew()) {
			   $this->collLogs = array();
			} else {

				$criteria->add(LogPeer::UTILISATEUR_ID, $this->id);

				LogPeer::addSelectColumns($criteria);
				$this->collLogs = LogPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(LogPeer::UTILISATEUR_ID, $this->id);

				LogPeer::addSelectColumns($criteria);
				if (!isset($this->lastLogCriteria) || !$this->lastLogCriteria->equals($criteria)) {
					$this->collLogs = LogPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastLogCriteria = $criteria;
		return $this->collLogs;
	}

	/**
	 * Returns the number of related Log objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Log objects.
	 * @throws     PropelException
	 */
	public function countLogs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collLogs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(LogPeer::UTILISATEUR_ID, $this->id);

				$count = LogPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(LogPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastLogCriteria) || !$this->lastLogCriteria->equals($criteria)) {
					$count = LogPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collLogs);
				}
			} else {
				$count = count($this->collLogs);
			}
		}
		$this->lastLogCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Log object to this object
	 * through the Log foreign key attribute.
	 *
	 * @param      Log $l Log
	 * @return     void
	 * @throws     PropelException
	 */
	public function addLog(Log $l)
	{
		if ($this->collLogs === null) {
			$this->initLogs();
		}
		if (!in_array($l, $this->collLogs, true)) { // only add it if the **same** object is not already associated
			array_push($this->collLogs, $l);
			$l->setUtilisateur($this);
		}
	}

	/**
	 * Clears out the collQuestions collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addQuestions()
	 */
	public function clearQuestions()
	{
		$this->collQuestions = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collQuestions collection (array).
	 *
	 * By default this just sets the collQuestions collection to an empty array (like clearcollQuestions());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initQuestions()
	{
		$this->collQuestions = array();
	}

	/**
	 * Gets an array of Question objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Questions from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Question[]
	 * @throws     PropelException
	 */
	public function getQuestions($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collQuestions === null) {
			if ($this->isNew()) {
			   $this->collQuestions = array();
			} else {

				$criteria->add(QuestionPeer::UTILISATEUR_ID, $this->id);

				QuestionPeer::addSelectColumns($criteria);
				$this->collQuestions = QuestionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(QuestionPeer::UTILISATEUR_ID, $this->id);

				QuestionPeer::addSelectColumns($criteria);
				if (!isset($this->lastQuestionCriteria) || !$this->lastQuestionCriteria->equals($criteria)) {
					$this->collQuestions = QuestionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastQuestionCriteria = $criteria;
		return $this->collQuestions;
	}

	/**
	 * Returns the number of related Question objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Question objects.
	 * @throws     PropelException
	 */
	public function countQuestions(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collQuestions === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(QuestionPeer::UTILISATEUR_ID, $this->id);

				$count = QuestionPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(QuestionPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastQuestionCriteria) || !$this->lastQuestionCriteria->equals($criteria)) {
					$count = QuestionPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collQuestions);
				}
			} else {
				$count = count($this->collQuestions);
			}
		}
		$this->lastQuestionCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Question object to this object
	 * through the Question foreign key attribute.
	 *
	 * @param      Question $l Question
	 * @return     void
	 * @throws     PropelException
	 */
	public function addQuestion(Question $l)
	{
		if ($this->collQuestions === null) {
			$this->initQuestions();
		}
		if (!in_array($l, $this->collQuestions, true)) { // only add it if the **same** object is not already associated
			array_push($this->collQuestions, $l);
			$l->setUtilisateur($this);
		}
	}

	/**
	 * Clears out the collReponseQuestions collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addReponseQuestions()
	 */
	public function clearReponseQuestions()
	{
		$this->collReponseQuestions = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collReponseQuestions collection (array).
	 *
	 * By default this just sets the collReponseQuestions collection to an empty array (like clearcollReponseQuestions());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initReponseQuestions()
	{
		$this->collReponseQuestions = array();
	}

	/**
	 * Gets an array of ReponseQuestion objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related ReponseQuestions from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array ReponseQuestion[]
	 * @throws     PropelException
	 */
	public function getReponseQuestions($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collReponseQuestions === null) {
			if ($this->isNew()) {
			   $this->collReponseQuestions = array();
			} else {

				$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

				ReponseQuestionPeer::addSelectColumns($criteria);
				$this->collReponseQuestions = ReponseQuestionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

				ReponseQuestionPeer::addSelectColumns($criteria);
				if (!isset($this->lastReponseQuestionCriteria) || !$this->lastReponseQuestionCriteria->equals($criteria)) {
					$this->collReponseQuestions = ReponseQuestionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastReponseQuestionCriteria = $criteria;
		return $this->collReponseQuestions;
	}

	/**
	 * Returns the number of related ReponseQuestion objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related ReponseQuestion objects.
	 * @throws     PropelException
	 */
	public function countReponseQuestions(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collReponseQuestions === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

				$count = ReponseQuestionPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastReponseQuestionCriteria) || !$this->lastReponseQuestionCriteria->equals($criteria)) {
					$count = ReponseQuestionPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collReponseQuestions);
				}
			} else {
				$count = count($this->collReponseQuestions);
			}
		}
		$this->lastReponseQuestionCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a ReponseQuestion object to this object
	 * through the ReponseQuestion foreign key attribute.
	 *
	 * @param      ReponseQuestion $l ReponseQuestion
	 * @return     void
	 * @throws     PropelException
	 */
	public function addReponseQuestion(ReponseQuestion $l)
	{
		if ($this->collReponseQuestions === null) {
			$this->initReponseQuestions();
		}
		if (!in_array($l, $this->collReponseQuestions, true)) { // only add it if the **same** object is not already associated
			array_push($this->collReponseQuestions, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related ReponseQuestions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getReponseQuestionsJoinQuestion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collReponseQuestions === null) {
			if ($this->isNew()) {
				$this->collReponseQuestions = array();
			} else {

				$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

				$this->collReponseQuestions = ReponseQuestionPeer::doSelectJoinQuestion($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ReponseQuestionPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastReponseQuestionCriteria) || !$this->lastReponseQuestionCriteria->equals($criteria)) {
				$this->collReponseQuestions = ReponseQuestionPeer::doSelectJoinQuestion($criteria, $con, $join_behavior);
			}
		}
		$this->lastReponseQuestionCriteria = $criteria;

		return $this->collReponseQuestions;
	}

	/**
	 * Clears out the collCompetences collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addCompetences()
	 */
	public function clearCompetences()
	{
		$this->collCompetences = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collCompetences collection (array).
	 *
	 * By default this just sets the collCompetences collection to an empty array (like clearcollCompetences());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initCompetences()
	{
		$this->collCompetences = array();
	}

	/**
	 * Gets an array of Competence objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Competences from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Competence[]
	 * @throws     PropelException
	 */
	public function getCompetences($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetences === null) {
			if ($this->isNew()) {
			   $this->collCompetences = array();
			} else {

				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				CompetencePeer::addSelectColumns($criteria);
				$this->collCompetences = CompetencePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				CompetencePeer::addSelectColumns($criteria);
				if (!isset($this->lastCompetenceCriteria) || !$this->lastCompetenceCriteria->equals($criteria)) {
					$this->collCompetences = CompetencePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCompetenceCriteria = $criteria;
		return $this->collCompetences;
	}

	/**
	 * Returns the number of related Competence objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Competence objects.
	 * @throws     PropelException
	 */
	public function countCompetences(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCompetences === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				$count = CompetencePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastCompetenceCriteria) || !$this->lastCompetenceCriteria->equals($criteria)) {
					$count = CompetencePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCompetences);
				}
			} else {
				$count = count($this->collCompetences);
			}
		}
		$this->lastCompetenceCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Competence object to this object
	 * through the Competence foreign key attribute.
	 *
	 * @param      Competence $l Competence
	 * @return     void
	 * @throws     PropelException
	 */
	public function addCompetence(Competence $l)
	{
		if ($this->collCompetences === null) {
			$this->initCompetences();
		}
		if (!in_array($l, $this->collCompetences, true)) { // only add it if the **same** object is not already associated
			array_push($this->collCompetences, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related Competences from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getCompetencesJoinCompetenceGrp($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetences === null) {
			if ($this->isNew()) {
				$this->collCompetences = array();
			} else {

				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				$this->collCompetences = CompetencePeer::doSelectJoinCompetenceGrp($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastCompetenceCriteria) || !$this->lastCompetenceCriteria->equals($criteria)) {
				$this->collCompetences = CompetencePeer::doSelectJoinCompetenceGrp($criteria, $con, $join_behavior);
			}
		}
		$this->lastCompetenceCriteria = $criteria;

		return $this->collCompetences;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related Competences from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getCompetencesJoinCompetenceRelatedByCompetenceId($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetences === null) {
			if ($this->isNew()) {
				$this->collCompetences = array();
			} else {

				$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

				$this->collCompetences = CompetencePeer::doSelectJoinCompetenceRelatedByCompetenceId($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(CompetencePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastCompetenceCriteria) || !$this->lastCompetenceCriteria->equals($criteria)) {
				$this->collCompetences = CompetencePeer::doSelectJoinCompetenceRelatedByCompetenceId($criteria, $con, $join_behavior);
			}
		}
		$this->lastCompetenceCriteria = $criteria;

		return $this->collCompetences;
	}

	/**
	 * Clears out the collJCompetencesProfesseurss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJCompetencesProfesseurss()
	 */
	public function clearJCompetencesProfesseurss()
	{
		$this->collJCompetencesProfesseurss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJCompetencesProfesseurss collection (array).
	 *
	 * By default this just sets the collJCompetencesProfesseurss collection to an empty array (like clearcollJCompetencesProfesseurss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJCompetencesProfesseurss()
	{
		$this->collJCompetencesProfesseurss = array();
	}

	/**
	 * Gets an array of JCompetencesProfesseurs objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JCompetencesProfesseurss from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JCompetencesProfesseurs[]
	 * @throws     PropelException
	 */
	public function getJCompetencesProfesseurss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJCompetencesProfesseurss === null) {
			if ($this->isNew()) {
			   $this->collJCompetencesProfesseurss = array();
			} else {

				$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

				JCompetencesProfesseursPeer::addSelectColumns($criteria);
				$this->collJCompetencesProfesseurss = JCompetencesProfesseursPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

				JCompetencesProfesseursPeer::addSelectColumns($criteria);
				if (!isset($this->lastJCompetencesProfesseursCriteria) || !$this->lastJCompetencesProfesseursCriteria->equals($criteria)) {
					$this->collJCompetencesProfesseurss = JCompetencesProfesseursPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJCompetencesProfesseursCriteria = $criteria;
		return $this->collJCompetencesProfesseurss;
	}

	/**
	 * Returns the number of related JCompetencesProfesseurs objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JCompetencesProfesseurs objects.
	 * @throws     PropelException
	 */
	public function countJCompetencesProfesseurss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJCompetencesProfesseurss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

				$count = JCompetencesProfesseursPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastJCompetencesProfesseursCriteria) || !$this->lastJCompetencesProfesseursCriteria->equals($criteria)) {
					$count = JCompetencesProfesseursPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJCompetencesProfesseurss);
				}
			} else {
				$count = count($this->collJCompetencesProfesseurss);
			}
		}
		$this->lastJCompetencesProfesseursCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JCompetencesProfesseurs object to this object
	 * through the JCompetencesProfesseurs foreign key attribute.
	 *
	 * @param      JCompetencesProfesseurs $l JCompetencesProfesseurs
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJCompetencesProfesseurs(JCompetencesProfesseurs $l)
	{
		if ($this->collJCompetencesProfesseurss === null) {
			$this->initJCompetencesProfesseurss();
		}
		if (!in_array($l, $this->collJCompetencesProfesseurss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJCompetencesProfesseurss, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JCompetencesProfesseurss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJCompetencesProfesseurssJoinCompetence($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJCompetencesProfesseurss === null) {
			if ($this->isNew()) {
				$this->collJCompetencesProfesseurss = array();
			} else {

				$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

				$this->collJCompetencesProfesseurss = JCompetencesProfesseursPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JCompetencesProfesseursPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastJCompetencesProfesseursCriteria) || !$this->lastJCompetencesProfesseursCriteria->equals($criteria)) {
				$this->collJCompetencesProfesseurss = JCompetencesProfesseursPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		}
		$this->lastJCompetencesProfesseursCriteria = $criteria;

		return $this->collJCompetencesProfesseurss;
	}

	/**
	 * Clears out the collJCompetencegrpUtilisateurs collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJCompetencegrpUtilisateurs()
	 */
	public function clearJCompetencegrpUtilisateurs()
	{
		$this->collJCompetencegrpUtilisateurs = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJCompetencegrpUtilisateurs collection (array).
	 *
	 * By default this just sets the collJCompetencegrpUtilisateurs collection to an empty array (like clearcollJCompetencegrpUtilisateurs());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJCompetencegrpUtilisateurs()
	{
		$this->collJCompetencegrpUtilisateurs = array();
	}

	/**
	 * Gets an array of JCompetencegrpUtilisateur objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JCompetencegrpUtilisateurs from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JCompetencegrpUtilisateur[]
	 * @throws     PropelException
	 */
	public function getJCompetencegrpUtilisateurs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJCompetencegrpUtilisateurs === null) {
			if ($this->isNew()) {
			   $this->collJCompetencegrpUtilisateurs = array();
			} else {

				$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

				JCompetencegrpUtilisateurPeer::addSelectColumns($criteria);
				$this->collJCompetencegrpUtilisateurs = JCompetencegrpUtilisateurPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

				JCompetencegrpUtilisateurPeer::addSelectColumns($criteria);
				if (!isset($this->lastJCompetencegrpUtilisateurCriteria) || !$this->lastJCompetencegrpUtilisateurCriteria->equals($criteria)) {
					$this->collJCompetencegrpUtilisateurs = JCompetencegrpUtilisateurPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJCompetencegrpUtilisateurCriteria = $criteria;
		return $this->collJCompetencegrpUtilisateurs;
	}

	/**
	 * Returns the number of related JCompetencegrpUtilisateur objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JCompetencegrpUtilisateur objects.
	 * @throws     PropelException
	 */
	public function countJCompetencegrpUtilisateurs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJCompetencegrpUtilisateurs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

				$count = JCompetencegrpUtilisateurPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJCompetencegrpUtilisateurCriteria) || !$this->lastJCompetencegrpUtilisateurCriteria->equals($criteria)) {
					$count = JCompetencegrpUtilisateurPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJCompetencegrpUtilisateurs);
				}
			} else {
				$count = count($this->collJCompetencegrpUtilisateurs);
			}
		}
		$this->lastJCompetencegrpUtilisateurCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JCompetencegrpUtilisateur object to this object
	 * through the JCompetencegrpUtilisateur foreign key attribute.
	 *
	 * @param      JCompetencegrpUtilisateur $l JCompetencegrpUtilisateur
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJCompetencegrpUtilisateur(JCompetencegrpUtilisateur $l)
	{
		if ($this->collJCompetencegrpUtilisateurs === null) {
			$this->initJCompetencegrpUtilisateurs();
		}
		if (!in_array($l, $this->collJCompetencegrpUtilisateurs, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJCompetencegrpUtilisateurs, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JCompetencegrpUtilisateurs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJCompetencegrpUtilisateursJoinCompetenceGrp($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJCompetencegrpUtilisateurs === null) {
			if ($this->isNew()) {
				$this->collJCompetencegrpUtilisateurs = array();
			} else {

				$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

				$this->collJCompetencegrpUtilisateurs = JCompetencegrpUtilisateurPeer::doSelectJoinCompetenceGrp($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJCompetencegrpUtilisateurCriteria) || !$this->lastJCompetencegrpUtilisateurCriteria->equals($criteria)) {
				$this->collJCompetencegrpUtilisateurs = JCompetencegrpUtilisateurPeer::doSelectJoinCompetenceGrp($criteria, $con, $join_behavior);
			}
		}
		$this->lastJCompetencegrpUtilisateurCriteria = $criteria;

		return $this->collJCompetencegrpUtilisateurs;
	}

	/**
	 * Clears out the collGrilles collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addGrilles()
	 */
	public function clearGrilles()
	{
		$this->collGrilles = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collGrilles collection (array).
	 *
	 * By default this just sets the collGrilles collection to an empty array (like clearcollGrilles());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initGrilles()
	{
		$this->collGrilles = array();
	}

	/**
	 * Gets an array of Grille objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Grilles from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Grille[]
	 * @throws     PropelException
	 */
	public function getGrilles($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGrilles === null) {
			if ($this->isNew()) {
			   $this->collGrilles = array();
			} else {

				$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

				GrillePeer::addSelectColumns($criteria);
				$this->collGrilles = GrillePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

				GrillePeer::addSelectColumns($criteria);
				if (!isset($this->lastGrilleCriteria) || !$this->lastGrilleCriteria->equals($criteria)) {
					$this->collGrilles = GrillePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGrilleCriteria = $criteria;
		return $this->collGrilles;
	}

	/**
	 * Returns the number of related Grille objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Grille objects.
	 * @throws     PropelException
	 */
	public function countGrilles(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGrilles === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

				$count = GrillePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastGrilleCriteria) || !$this->lastGrilleCriteria->equals($criteria)) {
					$count = GrillePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGrilles);
				}
			} else {
				$count = count($this->collGrilles);
			}
		}
		$this->lastGrilleCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Grille object to this object
	 * through the Grille foreign key attribute.
	 *
	 * @param      Grille $l Grille
	 * @return     void
	 * @throws     PropelException
	 */
	public function addGrille(Grille $l)
	{
		if ($this->collGrilles === null) {
			$this->initGrilles();
		}
		if (!in_array($l, $this->collGrilles, true)) { // only add it if the **same** object is not already associated
			array_push($this->collGrilles, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related Grilles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getGrillesJoinMatiere($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGrilles === null) {
			if ($this->isNew()) {
				$this->collGrilles = array();
			} else {

				$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

				$this->collGrilles = GrillePeer::doSelectJoinMatiere($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(GrillePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastGrilleCriteria) || !$this->lastGrilleCriteria->equals($criteria)) {
				$this->collGrilles = GrillePeer::doSelectJoinMatiere($criteria, $con, $join_behavior);
			}
		}
		$this->lastGrilleCriteria = $criteria;

		return $this->collGrilles;
	}

	/**
	 * Clears out the collJGrilleUtilisateurs collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJGrilleUtilisateurs()
	 */
	public function clearJGrilleUtilisateurs()
	{
		$this->collJGrilleUtilisateurs = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJGrilleUtilisateurs collection (array).
	 *
	 * By default this just sets the collJGrilleUtilisateurs collection to an empty array (like clearcollJGrilleUtilisateurs());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJGrilleUtilisateurs()
	{
		$this->collJGrilleUtilisateurs = array();
	}

	/**
	 * Gets an array of JGrilleUtilisateur objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JGrilleUtilisateurs from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JGrilleUtilisateur[]
	 * @throws     PropelException
	 */
	public function getJGrilleUtilisateurs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGrilleUtilisateurs === null) {
			if ($this->isNew()) {
			   $this->collJGrilleUtilisateurs = array();
			} else {

				$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

				JGrilleUtilisateurPeer::addSelectColumns($criteria);
				$this->collJGrilleUtilisateurs = JGrilleUtilisateurPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

				JGrilleUtilisateurPeer::addSelectColumns($criteria);
				if (!isset($this->lastJGrilleUtilisateurCriteria) || !$this->lastJGrilleUtilisateurCriteria->equals($criteria)) {
					$this->collJGrilleUtilisateurs = JGrilleUtilisateurPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJGrilleUtilisateurCriteria = $criteria;
		return $this->collJGrilleUtilisateurs;
	}

	/**
	 * Returns the number of related JGrilleUtilisateur objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JGrilleUtilisateur objects.
	 * @throws     PropelException
	 */
	public function countJGrilleUtilisateurs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJGrilleUtilisateurs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

				$count = JGrilleUtilisateurPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJGrilleUtilisateurCriteria) || !$this->lastJGrilleUtilisateurCriteria->equals($criteria)) {
					$count = JGrilleUtilisateurPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJGrilleUtilisateurs);
				}
			} else {
				$count = count($this->collJGrilleUtilisateurs);
			}
		}
		$this->lastJGrilleUtilisateurCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JGrilleUtilisateur object to this object
	 * through the JGrilleUtilisateur foreign key attribute.
	 *
	 * @param      JGrilleUtilisateur $l JGrilleUtilisateur
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJGrilleUtilisateur(JGrilleUtilisateur $l)
	{
		if ($this->collJGrilleUtilisateurs === null) {
			$this->initJGrilleUtilisateurs();
		}
		if (!in_array($l, $this->collJGrilleUtilisateurs, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJGrilleUtilisateurs, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JGrilleUtilisateurs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJGrilleUtilisateursJoinGrille($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGrilleUtilisateurs === null) {
			if ($this->isNew()) {
				$this->collJGrilleUtilisateurs = array();
			} else {

				$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

				$this->collJGrilleUtilisateurs = JGrilleUtilisateurPeer::doSelectJoinGrille($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JGrilleUtilisateurPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJGrilleUtilisateurCriteria) || !$this->lastJGrilleUtilisateurCriteria->equals($criteria)) {
				$this->collJGrilleUtilisateurs = JGrilleUtilisateurPeer::doSelectJoinGrille($criteria, $con, $join_behavior);
			}
		}
		$this->lastJGrilleUtilisateurCriteria = $criteria;

		return $this->collJGrilleUtilisateurs;
	}

	/**
	 * Clears out the collJControlePossesseurs collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJControlePossesseurs()
	 */
	public function clearJControlePossesseurs()
	{
		$this->collJControlePossesseurs = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJControlePossesseurs collection (array).
	 *
	 * By default this just sets the collJControlePossesseurs collection to an empty array (like clearcollJControlePossesseurs());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJControlePossesseurs()
	{
		$this->collJControlePossesseurs = array();
	}

	/**
	 * Gets an array of JControlePossesseur objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JControlePossesseurs from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JControlePossesseur[]
	 * @throws     PropelException
	 */
	public function getJControlePossesseurs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControlePossesseurs === null) {
			if ($this->isNew()) {
			   $this->collJControlePossesseurs = array();
			} else {

				$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

				JControlePossesseurPeer::addSelectColumns($criteria);
				$this->collJControlePossesseurs = JControlePossesseurPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

				JControlePossesseurPeer::addSelectColumns($criteria);
				if (!isset($this->lastJControlePossesseurCriteria) || !$this->lastJControlePossesseurCriteria->equals($criteria)) {
					$this->collJControlePossesseurs = JControlePossesseurPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJControlePossesseurCriteria = $criteria;
		return $this->collJControlePossesseurs;
	}

	/**
	 * Returns the number of related JControlePossesseur objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JControlePossesseur objects.
	 * @throws     PropelException
	 */
	public function countJControlePossesseurs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJControlePossesseurs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

				$count = JControlePossesseurPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJControlePossesseurCriteria) || !$this->lastJControlePossesseurCriteria->equals($criteria)) {
					$count = JControlePossesseurPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJControlePossesseurs);
				}
			} else {
				$count = count($this->collJControlePossesseurs);
			}
		}
		$this->lastJControlePossesseurCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JControlePossesseur object to this object
	 * through the JControlePossesseur foreign key attribute.
	 *
	 * @param      JControlePossesseur $l JControlePossesseur
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJControlePossesseur(JControlePossesseur $l)
	{
		if ($this->collJControlePossesseurs === null) {
			$this->initJControlePossesseurs();
		}
		if (!in_array($l, $this->collJControlePossesseurs, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJControlePossesseurs, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JControlePossesseurs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJControlePossesseursJoinControle($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControlePossesseurs === null) {
			if ($this->isNew()) {
				$this->collJControlePossesseurs = array();
			} else {

				$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

				$this->collJControlePossesseurs = JControlePossesseurPeer::doSelectJoinControle($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJControlePossesseurCriteria) || !$this->lastJControlePossesseurCriteria->equals($criteria)) {
				$this->collJControlePossesseurs = JControlePossesseurPeer::doSelectJoinControle($criteria, $con, $join_behavior);
			}
		}
		$this->lastJControlePossesseurCriteria = $criteria;

		return $this->collJControlePossesseurs;
	}

	/**
	 * Clears out the collJControleResultats collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJControleResultats()
	 */
	public function clearJControleResultats()
	{
		$this->collJControleResultats = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJControleResultats collection (array).
	 *
	 * By default this just sets the collJControleResultats collection to an empty array (like clearcollJControleResultats());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJControleResultats()
	{
		$this->collJControleResultats = array();
	}

	/**
	 * Gets an array of JControleResultat objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JControleResultats from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JControleResultat[]
	 * @throws     PropelException
	 */
	public function getJControleResultats($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControleResultats === null) {
			if ($this->isNew()) {
			   $this->collJControleResultats = array();
			} else {

				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				JControleResultatPeer::addSelectColumns($criteria);
				$this->collJControleResultats = JControleResultatPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				JControleResultatPeer::addSelectColumns($criteria);
				if (!isset($this->lastJControleResultatCriteria) || !$this->lastJControleResultatCriteria->equals($criteria)) {
					$this->collJControleResultats = JControleResultatPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJControleResultatCriteria = $criteria;
		return $this->collJControleResultats;
	}

	/**
	 * Returns the number of related JControleResultat objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JControleResultat objects.
	 * @throws     PropelException
	 */
	public function countJControleResultats(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJControleResultats === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				$count = JControleResultatPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJControleResultatCriteria) || !$this->lastJControleResultatCriteria->equals($criteria)) {
					$count = JControleResultatPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJControleResultats);
				}
			} else {
				$count = count($this->collJControleResultats);
			}
		}
		$this->lastJControleResultatCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JControleResultat object to this object
	 * through the JControleResultat foreign key attribute.
	 *
	 * @param      JControleResultat $l JControleResultat
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJControleResultat(JControleResultat $l)
	{
		if ($this->collJControleResultats === null) {
			$this->initJControleResultats();
		}
		if (!in_array($l, $this->collJControleResultats, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJControleResultats, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JControleResultats from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJControleResultatsJoinControle($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControleResultats === null) {
			if ($this->isNew()) {
				$this->collJControleResultats = array();
			} else {

				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				$this->collJControleResultats = JControleResultatPeer::doSelectJoinControle($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJControleResultatCriteria) || !$this->lastJControleResultatCriteria->equals($criteria)) {
				$this->collJControleResultats = JControleResultatPeer::doSelectJoinControle($criteria, $con, $join_behavior);
			}
		}
		$this->lastJControleResultatCriteria = $criteria;

		return $this->collJControleResultats;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JControleResultats from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJControleResultatsJoinCompetence($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControleResultats === null) {
			if ($this->isNew()) {
				$this->collJControleResultats = array();
			} else {

				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				$this->collJControleResultats = JControleResultatPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJControleResultatCriteria) || !$this->lastJControleResultatCriteria->equals($criteria)) {
				$this->collJControleResultats = JControleResultatPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		}
		$this->lastJControleResultatCriteria = $criteria;

		return $this->collJControleResultats;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JControleResultats from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJControleResultatsJoinValidationNiveau($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJControleResultats === null) {
			if ($this->isNew()) {
				$this->collJControleResultats = array();
			} else {

				$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

				$this->collJControleResultats = JControleResultatPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JControleResultatPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJControleResultatCriteria) || !$this->lastJControleResultatCriteria->equals($criteria)) {
				$this->collJControleResultats = JControleResultatPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		}
		$this->lastJControleResultatCriteria = $criteria;

		return $this->collJControleResultats;
	}

	/**
	 * Clears out the collJGroupePossesseurs collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJGroupePossesseurs()
	 */
	public function clearJGroupePossesseurs()
	{
		$this->collJGroupePossesseurs = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJGroupePossesseurs collection (array).
	 *
	 * By default this just sets the collJGroupePossesseurs collection to an empty array (like clearcollJGroupePossesseurs());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJGroupePossesseurs()
	{
		$this->collJGroupePossesseurs = array();
	}

	/**
	 * Gets an array of JGroupePossesseur objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JGroupePossesseurs from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JGroupePossesseur[]
	 * @throws     PropelException
	 */
	public function getJGroupePossesseurs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGroupePossesseurs === null) {
			if ($this->isNew()) {
			   $this->collJGroupePossesseurs = array();
			} else {

				$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

				JGroupePossesseurPeer::addSelectColumns($criteria);
				$this->collJGroupePossesseurs = JGroupePossesseurPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

				JGroupePossesseurPeer::addSelectColumns($criteria);
				if (!isset($this->lastJGroupePossesseurCriteria) || !$this->lastJGroupePossesseurCriteria->equals($criteria)) {
					$this->collJGroupePossesseurs = JGroupePossesseurPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJGroupePossesseurCriteria = $criteria;
		return $this->collJGroupePossesseurs;
	}

	/**
	 * Returns the number of related JGroupePossesseur objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JGroupePossesseur objects.
	 * @throws     PropelException
	 */
	public function countJGroupePossesseurs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJGroupePossesseurs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

				$count = JGroupePossesseurPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJGroupePossesseurCriteria) || !$this->lastJGroupePossesseurCriteria->equals($criteria)) {
					$count = JGroupePossesseurPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJGroupePossesseurs);
				}
			} else {
				$count = count($this->collJGroupePossesseurs);
			}
		}
		$this->lastJGroupePossesseurCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JGroupePossesseur object to this object
	 * through the JGroupePossesseur foreign key attribute.
	 *
	 * @param      JGroupePossesseur $l JGroupePossesseur
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJGroupePossesseur(JGroupePossesseur $l)
	{
		if ($this->collJGroupePossesseurs === null) {
			$this->initJGroupePossesseurs();
		}
		if (!in_array($l, $this->collJGroupePossesseurs, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJGroupePossesseurs, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JGroupePossesseurs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJGroupePossesseursJoinGroupe($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGroupePossesseurs === null) {
			if ($this->isNew()) {
				$this->collJGroupePossesseurs = array();
			} else {

				$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

				$this->collJGroupePossesseurs = JGroupePossesseurPeer::doSelectJoinGroupe($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJGroupePossesseurCriteria) || !$this->lastJGroupePossesseurCriteria->equals($criteria)) {
				$this->collJGroupePossesseurs = JGroupePossesseurPeer::doSelectJoinGroupe($criteria, $con, $join_behavior);
			}
		}
		$this->lastJGroupePossesseurCriteria = $criteria;

		return $this->collJGroupePossesseurs;
	}

	/**
	 * Clears out the collJGroupeEleves collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJGroupeEleves()
	 */
	public function clearJGroupeEleves()
	{
		$this->collJGroupeEleves = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJGroupeEleves collection (array).
	 *
	 * By default this just sets the collJGroupeEleves collection to an empty array (like clearcollJGroupeEleves());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJGroupeEleves()
	{
		$this->collJGroupeEleves = array();
	}

	/**
	 * Gets an array of JGroupeEleve objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JGroupeEleves from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JGroupeEleve[]
	 * @throws     PropelException
	 */
	public function getJGroupeEleves($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGroupeEleves === null) {
			if ($this->isNew()) {
			   $this->collJGroupeEleves = array();
			} else {

				$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

				JGroupeElevePeer::addSelectColumns($criteria);
				$this->collJGroupeEleves = JGroupeElevePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

				JGroupeElevePeer::addSelectColumns($criteria);
				if (!isset($this->lastJGroupeEleveCriteria) || !$this->lastJGroupeEleveCriteria->equals($criteria)) {
					$this->collJGroupeEleves = JGroupeElevePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJGroupeEleveCriteria = $criteria;
		return $this->collJGroupeEleves;
	}

	/**
	 * Returns the number of related JGroupeEleve objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JGroupeEleve objects.
	 * @throws     PropelException
	 */
	public function countJGroupeEleves(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJGroupeEleves === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

				$count = JGroupeElevePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJGroupeEleveCriteria) || !$this->lastJGroupeEleveCriteria->equals($criteria)) {
					$count = JGroupeElevePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJGroupeEleves);
				}
			} else {
				$count = count($this->collJGroupeEleves);
			}
		}
		$this->lastJGroupeEleveCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JGroupeEleve object to this object
	 * through the JGroupeEleve foreign key attribute.
	 *
	 * @param      JGroupeEleve $l JGroupeEleve
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJGroupeEleve(JGroupeEleve $l)
	{
		if ($this->collJGroupeEleves === null) {
			$this->initJGroupeEleves();
		}
		if (!in_array($l, $this->collJGroupeEleves, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJGroupeEleves, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JGroupeEleves from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJGroupeElevesJoinGroupe($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJGroupeEleves === null) {
			if ($this->isNew()) {
				$this->collJGroupeEleves = array();
			} else {

				$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

				$this->collJGroupeEleves = JGroupeElevePeer::doSelectJoinGroupe($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JGroupeElevePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJGroupeEleveCriteria) || !$this->lastJGroupeEleveCriteria->equals($criteria)) {
				$this->collJGroupeEleves = JGroupeElevePeer::doSelectJoinGroupe($criteria, $con, $join_behavior);
			}
		}
		$this->lastJGroupeEleveCriteria = $criteria;

		return $this->collJGroupeEleves;
	}

	/**
	 * Clears out the collBilansRelatedByProfesseurId collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addBilansRelatedByProfesseurId()
	 */
	public function clearBilansRelatedByProfesseurId()
	{
		$this->collBilansRelatedByProfesseurId = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collBilansRelatedByProfesseurId collection (array).
	 *
	 * By default this just sets the collBilansRelatedByProfesseurId collection to an empty array (like clearcollBilansRelatedByProfesseurId());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initBilansRelatedByProfesseurId()
	{
		$this->collBilansRelatedByProfesseurId = array();
	}

	/**
	 * Gets an array of Bilan objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related BilansRelatedByProfesseurId from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Bilan[]
	 * @throws     PropelException
	 */
	public function getBilansRelatedByProfesseurId($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByProfesseurId === null) {
			if ($this->isNew()) {
			   $this->collBilansRelatedByProfesseurId = array();
			} else {

				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				BilanPeer::addSelectColumns($criteria);
				$this->collBilansRelatedByProfesseurId = BilanPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				BilanPeer::addSelectColumns($criteria);
				if (!isset($this->lastBilanRelatedByProfesseurIdCriteria) || !$this->lastBilanRelatedByProfesseurIdCriteria->equals($criteria)) {
					$this->collBilansRelatedByProfesseurId = BilanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastBilanRelatedByProfesseurIdCriteria = $criteria;
		return $this->collBilansRelatedByProfesseurId;
	}

	/**
	 * Returns the number of related Bilan objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Bilan objects.
	 * @throws     PropelException
	 */
	public function countBilansRelatedByProfesseurId(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collBilansRelatedByProfesseurId === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				$count = BilanPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastBilanRelatedByProfesseurIdCriteria) || !$this->lastBilanRelatedByProfesseurIdCriteria->equals($criteria)) {
					$count = BilanPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collBilansRelatedByProfesseurId);
				}
			} else {
				$count = count($this->collBilansRelatedByProfesseurId);
			}
		}
		$this->lastBilanRelatedByProfesseurIdCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Bilan object to this object
	 * through the Bilan foreign key attribute.
	 *
	 * @param      Bilan $l Bilan
	 * @return     void
	 * @throws     PropelException
	 */
	public function addBilanRelatedByProfesseurId(Bilan $l)
	{
		if ($this->collBilansRelatedByProfesseurId === null) {
			$this->initBilansRelatedByProfesseurId();
		}
		if (!in_array($l, $this->collBilansRelatedByProfesseurId, true)) { // only add it if the **same** object is not already associated
			array_push($this->collBilansRelatedByProfesseurId, $l);
			$l->setUtilisateurRelatedByProfesseurId($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related BilansRelatedByProfesseurId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getBilansRelatedByProfesseurIdJoinCompetence($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByProfesseurId === null) {
			if ($this->isNew()) {
				$this->collBilansRelatedByProfesseurId = array();
			} else {

				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				$this->collBilansRelatedByProfesseurId = BilanPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastBilanRelatedByProfesseurIdCriteria) || !$this->lastBilanRelatedByProfesseurIdCriteria->equals($criteria)) {
				$this->collBilansRelatedByProfesseurId = BilanPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		}
		$this->lastBilanRelatedByProfesseurIdCriteria = $criteria;

		return $this->collBilansRelatedByProfesseurId;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related BilansRelatedByProfesseurId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getBilansRelatedByProfesseurIdJoinValidationNiveau($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByProfesseurId === null) {
			if ($this->isNew()) {
				$this->collBilansRelatedByProfesseurId = array();
			} else {

				$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

				$this->collBilansRelatedByProfesseurId = BilanPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(BilanPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastBilanRelatedByProfesseurIdCriteria) || !$this->lastBilanRelatedByProfesseurIdCriteria->equals($criteria)) {
				$this->collBilansRelatedByProfesseurId = BilanPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		}
		$this->lastBilanRelatedByProfesseurIdCriteria = $criteria;

		return $this->collBilansRelatedByProfesseurId;
	}

	/**
	 * Clears out the collBilansRelatedByEleveId collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addBilansRelatedByEleveId()
	 */
	public function clearBilansRelatedByEleveId()
	{
		$this->collBilansRelatedByEleveId = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collBilansRelatedByEleveId collection (array).
	 *
	 * By default this just sets the collBilansRelatedByEleveId collection to an empty array (like clearcollBilansRelatedByEleveId());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initBilansRelatedByEleveId()
	{
		$this->collBilansRelatedByEleveId = array();
	}

	/**
	 * Gets an array of Bilan objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related BilansRelatedByEleveId from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Bilan[]
	 * @throws     PropelException
	 */
	public function getBilansRelatedByEleveId($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByEleveId === null) {
			if ($this->isNew()) {
			   $this->collBilansRelatedByEleveId = array();
			} else {

				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				BilanPeer::addSelectColumns($criteria);
				$this->collBilansRelatedByEleveId = BilanPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				BilanPeer::addSelectColumns($criteria);
				if (!isset($this->lastBilanRelatedByEleveIdCriteria) || !$this->lastBilanRelatedByEleveIdCriteria->equals($criteria)) {
					$this->collBilansRelatedByEleveId = BilanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastBilanRelatedByEleveIdCriteria = $criteria;
		return $this->collBilansRelatedByEleveId;
	}

	/**
	 * Returns the number of related Bilan objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Bilan objects.
	 * @throws     PropelException
	 */
	public function countBilansRelatedByEleveId(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collBilansRelatedByEleveId === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				$count = BilanPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				if (!isset($this->lastBilanRelatedByEleveIdCriteria) || !$this->lastBilanRelatedByEleveIdCriteria->equals($criteria)) {
					$count = BilanPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collBilansRelatedByEleveId);
				}
			} else {
				$count = count($this->collBilansRelatedByEleveId);
			}
		}
		$this->lastBilanRelatedByEleveIdCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Bilan object to this object
	 * through the Bilan foreign key attribute.
	 *
	 * @param      Bilan $l Bilan
	 * @return     void
	 * @throws     PropelException
	 */
	public function addBilanRelatedByEleveId(Bilan $l)
	{
		if ($this->collBilansRelatedByEleveId === null) {
			$this->initBilansRelatedByEleveId();
		}
		if (!in_array($l, $this->collBilansRelatedByEleveId, true)) { // only add it if the **same** object is not already associated
			array_push($this->collBilansRelatedByEleveId, $l);
			$l->setUtilisateurRelatedByEleveId($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related BilansRelatedByEleveId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getBilansRelatedByEleveIdJoinCompetence($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByEleveId === null) {
			if ($this->isNew()) {
				$this->collBilansRelatedByEleveId = array();
			} else {

				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				$this->collBilansRelatedByEleveId = BilanPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(BilanPeer::ELEVE_ID, $this->id);

			if (!isset($this->lastBilanRelatedByEleveIdCriteria) || !$this->lastBilanRelatedByEleveIdCriteria->equals($criteria)) {
				$this->collBilansRelatedByEleveId = BilanPeer::doSelectJoinCompetence($criteria, $con, $join_behavior);
			}
		}
		$this->lastBilanRelatedByEleveIdCriteria = $criteria;

		return $this->collBilansRelatedByEleveId;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related BilansRelatedByEleveId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getBilansRelatedByEleveIdJoinValidationNiveau($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collBilansRelatedByEleveId === null) {
			if ($this->isNew()) {
				$this->collBilansRelatedByEleveId = array();
			} else {

				$criteria->add(BilanPeer::ELEVE_ID, $this->id);

				$this->collBilansRelatedByEleveId = BilanPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(BilanPeer::ELEVE_ID, $this->id);

			if (!isset($this->lastBilanRelatedByEleveIdCriteria) || !$this->lastBilanRelatedByEleveIdCriteria->equals($criteria)) {
				$this->collBilansRelatedByEleveId = BilanPeer::doSelectJoinValidationNiveau($criteria, $con, $join_behavior);
			}
		}
		$this->lastBilanRelatedByEleveIdCriteria = $criteria;

		return $this->collBilansRelatedByEleveId;
	}

	/**
	 * Clears out the collAppreciationsRelatedByProfesseurId collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addAppreciationsRelatedByProfesseurId()
	 */
	public function clearAppreciationsRelatedByProfesseurId()
	{
		$this->collAppreciationsRelatedByProfesseurId = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collAppreciationsRelatedByProfesseurId collection (array).
	 *
	 * By default this just sets the collAppreciationsRelatedByProfesseurId collection to an empty array (like clearcollAppreciationsRelatedByProfesseurId());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initAppreciationsRelatedByProfesseurId()
	{
		$this->collAppreciationsRelatedByProfesseurId = array();
	}

	/**
	 * Gets an array of Appreciation objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related AppreciationsRelatedByProfesseurId from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Appreciation[]
	 * @throws     PropelException
	 */
	public function getAppreciationsRelatedByProfesseurId($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAppreciationsRelatedByProfesseurId === null) {
			if ($this->isNew()) {
			   $this->collAppreciationsRelatedByProfesseurId = array();
			} else {

				$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

				AppreciationPeer::addSelectColumns($criteria);
				$this->collAppreciationsRelatedByProfesseurId = AppreciationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

				AppreciationPeer::addSelectColumns($criteria);
				if (!isset($this->lastAppreciationRelatedByProfesseurIdCriteria) || !$this->lastAppreciationRelatedByProfesseurIdCriteria->equals($criteria)) {
					$this->collAppreciationsRelatedByProfesseurId = AppreciationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAppreciationRelatedByProfesseurIdCriteria = $criteria;
		return $this->collAppreciationsRelatedByProfesseurId;
	}

	/**
	 * Returns the number of related Appreciation objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Appreciation objects.
	 * @throws     PropelException
	 */
	public function countAppreciationsRelatedByProfesseurId(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collAppreciationsRelatedByProfesseurId === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

				$count = AppreciationPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastAppreciationRelatedByProfesseurIdCriteria) || !$this->lastAppreciationRelatedByProfesseurIdCriteria->equals($criteria)) {
					$count = AppreciationPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collAppreciationsRelatedByProfesseurId);
				}
			} else {
				$count = count($this->collAppreciationsRelatedByProfesseurId);
			}
		}
		$this->lastAppreciationRelatedByProfesseurIdCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Appreciation object to this object
	 * through the Appreciation foreign key attribute.
	 *
	 * @param      Appreciation $l Appreciation
	 * @return     void
	 * @throws     PropelException
	 */
	public function addAppreciationRelatedByProfesseurId(Appreciation $l)
	{
		if ($this->collAppreciationsRelatedByProfesseurId === null) {
			$this->initAppreciationsRelatedByProfesseurId();
		}
		if (!in_array($l, $this->collAppreciationsRelatedByProfesseurId, true)) { // only add it if the **same** object is not already associated
			array_push($this->collAppreciationsRelatedByProfesseurId, $l);
			$l->setUtilisateurRelatedByProfesseurId($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related AppreciationsRelatedByProfesseurId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getAppreciationsRelatedByProfesseurIdJoinBulletin($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAppreciationsRelatedByProfesseurId === null) {
			if ($this->isNew()) {
				$this->collAppreciationsRelatedByProfesseurId = array();
			} else {

				$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

				$this->collAppreciationsRelatedByProfesseurId = AppreciationPeer::doSelectJoinBulletin($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(AppreciationPeer::PROFESSEUR_ID, $this->id);

			if (!isset($this->lastAppreciationRelatedByProfesseurIdCriteria) || !$this->lastAppreciationRelatedByProfesseurIdCriteria->equals($criteria)) {
				$this->collAppreciationsRelatedByProfesseurId = AppreciationPeer::doSelectJoinBulletin($criteria, $con, $join_behavior);
			}
		}
		$this->lastAppreciationRelatedByProfesseurIdCriteria = $criteria;

		return $this->collAppreciationsRelatedByProfesseurId;
	}

	/**
	 * Clears out the collAppreciationsRelatedByEleveId collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addAppreciationsRelatedByEleveId()
	 */
	public function clearAppreciationsRelatedByEleveId()
	{
		$this->collAppreciationsRelatedByEleveId = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collAppreciationsRelatedByEleveId collection (array).
	 *
	 * By default this just sets the collAppreciationsRelatedByEleveId collection to an empty array (like clearcollAppreciationsRelatedByEleveId());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initAppreciationsRelatedByEleveId()
	{
		$this->collAppreciationsRelatedByEleveId = array();
	}

	/**
	 * Gets an array of Appreciation objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related AppreciationsRelatedByEleveId from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Appreciation[]
	 * @throws     PropelException
	 */
	public function getAppreciationsRelatedByEleveId($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAppreciationsRelatedByEleveId === null) {
			if ($this->isNew()) {
			   $this->collAppreciationsRelatedByEleveId = array();
			} else {

				$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

				AppreciationPeer::addSelectColumns($criteria);
				$this->collAppreciationsRelatedByEleveId = AppreciationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

				AppreciationPeer::addSelectColumns($criteria);
				if (!isset($this->lastAppreciationRelatedByEleveIdCriteria) || !$this->lastAppreciationRelatedByEleveIdCriteria->equals($criteria)) {
					$this->collAppreciationsRelatedByEleveId = AppreciationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAppreciationRelatedByEleveIdCriteria = $criteria;
		return $this->collAppreciationsRelatedByEleveId;
	}

	/**
	 * Returns the number of related Appreciation objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Appreciation objects.
	 * @throws     PropelException
	 */
	public function countAppreciationsRelatedByEleveId(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collAppreciationsRelatedByEleveId === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

				$count = AppreciationPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

				if (!isset($this->lastAppreciationRelatedByEleveIdCriteria) || !$this->lastAppreciationRelatedByEleveIdCriteria->equals($criteria)) {
					$count = AppreciationPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collAppreciationsRelatedByEleveId);
				}
			} else {
				$count = count($this->collAppreciationsRelatedByEleveId);
			}
		}
		$this->lastAppreciationRelatedByEleveIdCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Appreciation object to this object
	 * through the Appreciation foreign key attribute.
	 *
	 * @param      Appreciation $l Appreciation
	 * @return     void
	 * @throws     PropelException
	 */
	public function addAppreciationRelatedByEleveId(Appreciation $l)
	{
		if ($this->collAppreciationsRelatedByEleveId === null) {
			$this->initAppreciationsRelatedByEleveId();
		}
		if (!in_array($l, $this->collAppreciationsRelatedByEleveId, true)) { // only add it if the **same** object is not already associated
			array_push($this->collAppreciationsRelatedByEleveId, $l);
			$l->setUtilisateurRelatedByEleveId($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related AppreciationsRelatedByEleveId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getAppreciationsRelatedByEleveIdJoinBulletin($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAppreciationsRelatedByEleveId === null) {
			if ($this->isNew()) {
				$this->collAppreciationsRelatedByEleveId = array();
			} else {

				$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

				$this->collAppreciationsRelatedByEleveId = AppreciationPeer::doSelectJoinBulletin($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(AppreciationPeer::ELEVE_ID, $this->id);

			if (!isset($this->lastAppreciationRelatedByEleveIdCriteria) || !$this->lastAppreciationRelatedByEleveIdCriteria->equals($criteria)) {
				$this->collAppreciationsRelatedByEleveId = AppreciationPeer::doSelectJoinBulletin($criteria, $con, $join_behavior);
			}
		}
		$this->lastAppreciationRelatedByEleveIdCriteria = $criteria;

		return $this->collAppreciationsRelatedByEleveId;
	}

	/**
	 * Clears out the collJDiscussionUtilisateurss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJDiscussionUtilisateurss()
	 */
	public function clearJDiscussionUtilisateurss()
	{
		$this->collJDiscussionUtilisateurss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJDiscussionUtilisateurss collection (array).
	 *
	 * By default this just sets the collJDiscussionUtilisateurss collection to an empty array (like clearcollJDiscussionUtilisateurss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJDiscussionUtilisateurss()
	{
		$this->collJDiscussionUtilisateurss = array();
	}

	/**
	 * Gets an array of JDiscussionUtilisateurs objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JDiscussionUtilisateurss from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JDiscussionUtilisateurs[]
	 * @throws     PropelException
	 */
	public function getJDiscussionUtilisateurss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJDiscussionUtilisateurss === null) {
			if ($this->isNew()) {
			   $this->collJDiscussionUtilisateurss = array();
			} else {

				$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

				JDiscussionUtilisateursPeer::addSelectColumns($criteria);
				$this->collJDiscussionUtilisateurss = JDiscussionUtilisateursPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

				JDiscussionUtilisateursPeer::addSelectColumns($criteria);
				if (!isset($this->lastJDiscussionUtilisateursCriteria) || !$this->lastJDiscussionUtilisateursCriteria->equals($criteria)) {
					$this->collJDiscussionUtilisateurss = JDiscussionUtilisateursPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJDiscussionUtilisateursCriteria = $criteria;
		return $this->collJDiscussionUtilisateurss;
	}

	/**
	 * Returns the number of related JDiscussionUtilisateurs objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JDiscussionUtilisateurs objects.
	 * @throws     PropelException
	 */
	public function countJDiscussionUtilisateurss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJDiscussionUtilisateurss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

				$count = JDiscussionUtilisateursPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJDiscussionUtilisateursCriteria) || !$this->lastJDiscussionUtilisateursCriteria->equals($criteria)) {
					$count = JDiscussionUtilisateursPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJDiscussionUtilisateurss);
				}
			} else {
				$count = count($this->collJDiscussionUtilisateurss);
			}
		}
		$this->lastJDiscussionUtilisateursCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JDiscussionUtilisateurs object to this object
	 * through the JDiscussionUtilisateurs foreign key attribute.
	 *
	 * @param      JDiscussionUtilisateurs $l JDiscussionUtilisateurs
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJDiscussionUtilisateurs(JDiscussionUtilisateurs $l)
	{
		if ($this->collJDiscussionUtilisateurss === null) {
			$this->initJDiscussionUtilisateurss();
		}
		if (!in_array($l, $this->collJDiscussionUtilisateurss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJDiscussionUtilisateurss, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JDiscussionUtilisateurss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJDiscussionUtilisateurssJoinDiscussion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJDiscussionUtilisateurss === null) {
			if ($this->isNew()) {
				$this->collJDiscussionUtilisateurss = array();
			} else {

				$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

				$this->collJDiscussionUtilisateurss = JDiscussionUtilisateursPeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JDiscussionUtilisateursPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJDiscussionUtilisateursCriteria) || !$this->lastJDiscussionUtilisateursCriteria->equals($criteria)) {
				$this->collJDiscussionUtilisateurss = JDiscussionUtilisateursPeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		}
		$this->lastJDiscussionUtilisateursCriteria = $criteria;

		return $this->collJDiscussionUtilisateurss;
	}

	/**
	 * Clears out the collEchanges collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addEchanges()
	 */
	public function clearEchanges()
	{
		$this->collEchanges = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collEchanges collection (array).
	 *
	 * By default this just sets the collEchanges collection to an empty array (like clearcollEchanges());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initEchanges()
	{
		$this->collEchanges = array();
	}

	/**
	 * Gets an array of Echange objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Echanges from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Echange[]
	 * @throws     PropelException
	 */
	public function getEchanges($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEchanges === null) {
			if ($this->isNew()) {
			   $this->collEchanges = array();
			} else {

				$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

				EchangePeer::addSelectColumns($criteria);
				$this->collEchanges = EchangePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

				EchangePeer::addSelectColumns($criteria);
				if (!isset($this->lastEchangeCriteria) || !$this->lastEchangeCriteria->equals($criteria)) {
					$this->collEchanges = EchangePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEchangeCriteria = $criteria;
		return $this->collEchanges;
	}

	/**
	 * Returns the number of related Echange objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Echange objects.
	 * @throws     PropelException
	 */
	public function countEchanges(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collEchanges === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

				$count = EchangePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastEchangeCriteria) || !$this->lastEchangeCriteria->equals($criteria)) {
					$count = EchangePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collEchanges);
				}
			} else {
				$count = count($this->collEchanges);
			}
		}
		$this->lastEchangeCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Echange object to this object
	 * through the Echange foreign key attribute.
	 *
	 * @param      Echange $l Echange
	 * @return     void
	 * @throws     PropelException
	 */
	public function addEchange(Echange $l)
	{
		if ($this->collEchanges === null) {
			$this->initEchanges();
		}
		if (!in_array($l, $this->collEchanges, true)) { // only add it if the **same** object is not already associated
			array_push($this->collEchanges, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related Echanges from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getEchangesJoinDiscussion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEchanges === null) {
			if ($this->isNew()) {
				$this->collEchanges = array();
			} else {

				$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

				$this->collEchanges = EchangePeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(EchangePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastEchangeCriteria) || !$this->lastEchangeCriteria->equals($criteria)) {
				$this->collEchanges = EchangePeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		}
		$this->lastEchangeCriteria = $criteria;

		return $this->collEchanges;
	}

	/**
	 * Clears out the collJDiscussionDocumentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJDiscussionDocumentss()
	 */
	public function clearJDiscussionDocumentss()
	{
		$this->collJDiscussionDocumentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJDiscussionDocumentss collection (array).
	 *
	 * By default this just sets the collJDiscussionDocumentss collection to an empty array (like clearcollJDiscussionDocumentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJDiscussionDocumentss()
	{
		$this->collJDiscussionDocumentss = array();
	}

	/**
	 * Gets an array of JDiscussionDocuments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JDiscussionDocumentss from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JDiscussionDocuments[]
	 * @throws     PropelException
	 */
	public function getJDiscussionDocumentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJDiscussionDocumentss === null) {
			if ($this->isNew()) {
			   $this->collJDiscussionDocumentss = array();
			} else {

				$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

				JDiscussionDocumentsPeer::addSelectColumns($criteria);
				$this->collJDiscussionDocumentss = JDiscussionDocumentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

				JDiscussionDocumentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastJDiscussionDocumentsCriteria) || !$this->lastJDiscussionDocumentsCriteria->equals($criteria)) {
					$this->collJDiscussionDocumentss = JDiscussionDocumentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJDiscussionDocumentsCriteria = $criteria;
		return $this->collJDiscussionDocumentss;
	}

	/**
	 * Returns the number of related JDiscussionDocuments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JDiscussionDocuments objects.
	 * @throws     PropelException
	 */
	public function countJDiscussionDocumentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJDiscussionDocumentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

				$count = JDiscussionDocumentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastJDiscussionDocumentsCriteria) || !$this->lastJDiscussionDocumentsCriteria->equals($criteria)) {
					$count = JDiscussionDocumentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJDiscussionDocumentss);
				}
			} else {
				$count = count($this->collJDiscussionDocumentss);
			}
		}
		$this->lastJDiscussionDocumentsCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JDiscussionDocuments object to this object
	 * through the JDiscussionDocuments foreign key attribute.
	 *
	 * @param      JDiscussionDocuments $l JDiscussionDocuments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJDiscussionDocuments(JDiscussionDocuments $l)
	{
		if ($this->collJDiscussionDocumentss === null) {
			$this->initJDiscussionDocumentss();
		}
		if (!in_array($l, $this->collJDiscussionDocumentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJDiscussionDocumentss, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JDiscussionDocumentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJDiscussionDocumentssJoinDiscussion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJDiscussionDocumentss === null) {
			if ($this->isNew()) {
				$this->collJDiscussionDocumentss = array();
			} else {

				$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

				$this->collJDiscussionDocumentss = JDiscussionDocumentsPeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JDiscussionDocumentsPeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastJDiscussionDocumentsCriteria) || !$this->lastJDiscussionDocumentsCriteria->equals($criteria)) {
				$this->collJDiscussionDocumentss = JDiscussionDocumentsPeer::doSelectJoinDiscussion($criteria, $con, $join_behavior);
			}
		}
		$this->lastJDiscussionDocumentsCriteria = $criteria;

		return $this->collJDiscussionDocumentss;
	}

	/**
	 * Clears out the collRessources collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addRessources()
	 */
	public function clearRessources()
	{
		$this->collRessources = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collRessources collection (array).
	 *
	 * By default this just sets the collRessources collection to an empty array (like clearcollRessources());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initRessources()
	{
		$this->collRessources = array();
	}

	/**
	 * Gets an array of Ressource objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Ressources from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Ressource[]
	 * @throws     PropelException
	 */
	public function getRessources($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRessources === null) {
			if ($this->isNew()) {
			   $this->collRessources = array();
			} else {

				$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

				RessourcePeer::addSelectColumns($criteria);
				$this->collRessources = RessourcePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

				RessourcePeer::addSelectColumns($criteria);
				if (!isset($this->lastRessourceCriteria) || !$this->lastRessourceCriteria->equals($criteria)) {
					$this->collRessources = RessourcePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRessourceCriteria = $criteria;
		return $this->collRessources;
	}

	/**
	 * Returns the number of related Ressource objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Ressource objects.
	 * @throws     PropelException
	 */
	public function countRessources(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collRessources === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

				$count = RessourcePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

				if (!isset($this->lastRessourceCriteria) || !$this->lastRessourceCriteria->equals($criteria)) {
					$count = RessourcePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collRessources);
				}
			} else {
				$count = count($this->collRessources);
			}
		}
		$this->lastRessourceCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Ressource object to this object
	 * through the Ressource foreign key attribute.
	 *
	 * @param      Ressource $l Ressource
	 * @return     void
	 * @throws     PropelException
	 */
	public function addRessource(Ressource $l)
	{
		if ($this->collRessources === null) {
			$this->initRessources();
		}
		if (!in_array($l, $this->collRessources, true)) { // only add it if the **same** object is not already associated
			array_push($this->collRessources, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related Ressources from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getRessourcesJoinMatiere($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRessources === null) {
			if ($this->isNew()) {
				$this->collRessources = array();
			} else {

				$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

				$this->collRessources = RessourcePeer::doSelectJoinMatiere($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(RessourcePeer::UTILISATEUR_ID, $this->id);

			if (!isset($this->lastRessourceCriteria) || !$this->lastRessourceCriteria->equals($criteria)) {
				$this->collRessources = RessourcePeer::doSelectJoinMatiere($criteria, $con, $join_behavior);
			}
		}
		$this->lastRessourceCriteria = $criteria;

		return $this->collRessources;
	}

	/**
	 * Clears out the collAttestations collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addAttestations()
	 */
	public function clearAttestations()
	{
		$this->collAttestations = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collAttestations collection (array).
	 *
	 * By default this just sets the collAttestations collection to an empty array (like clearcollAttestations());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initAttestations()
	{
		$this->collAttestations = array();
	}

	/**
	 * Gets an array of Attestation objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Attestations from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Attestation[]
	 * @throws     PropelException
	 */
	public function getAttestations($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAttestations === null) {
			if ($this->isNew()) {
			   $this->collAttestations = array();
			} else {

				$criteria->add(AttestationPeer::ELEVE_ID, $this->id);

				AttestationPeer::addSelectColumns($criteria);
				$this->collAttestations = AttestationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(AttestationPeer::ELEVE_ID, $this->id);

				AttestationPeer::addSelectColumns($criteria);
				if (!isset($this->lastAttestationCriteria) || !$this->lastAttestationCriteria->equals($criteria)) {
					$this->collAttestations = AttestationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAttestationCriteria = $criteria;
		return $this->collAttestations;
	}

	/**
	 * Returns the number of related Attestation objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Attestation objects.
	 * @throws     PropelException
	 */
	public function countAttestations(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collAttestations === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(AttestationPeer::ELEVE_ID, $this->id);

				$count = AttestationPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(AttestationPeer::ELEVE_ID, $this->id);

				if (!isset($this->lastAttestationCriteria) || !$this->lastAttestationCriteria->equals($criteria)) {
					$count = AttestationPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collAttestations);
				}
			} else {
				$count = count($this->collAttestations);
			}
		}
		$this->lastAttestationCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Attestation object to this object
	 * through the Attestation foreign key attribute.
	 *
	 * @param      Attestation $l Attestation
	 * @return     void
	 * @throws     PropelException
	 */
	public function addAttestation(Attestation $l)
	{
		if ($this->collAttestations === null) {
			$this->initAttestations();
		}
		if (!in_array($l, $this->collAttestations, true)) { // only add it if the **same** object is not already associated
			array_push($this->collAttestations, $l);
			$l->setUtilisateur($this);
		}
	}

	/**
	 * Clears out the collExercices collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addExercices()
	 */
	public function clearExercices()
	{
		$this->collExercices = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collExercices collection (array).
	 *
	 * By default this just sets the collExercices collection to an empty array (like clearcollExercices());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initExercices()
	{
		$this->collExercices = array();
	}

	/**
	 * Gets an array of Exercice objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related Exercices from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Exercice[]
	 * @throws     PropelException
	 */
	public function getExercices($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExercices === null) {
			if ($this->isNew()) {
			   $this->collExercices = array();
			} else {

				$criteria->add(ExercicePeer::PROFESSEUR_ID, $this->id);

				ExercicePeer::addSelectColumns($criteria);
				$this->collExercices = ExercicePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ExercicePeer::PROFESSEUR_ID, $this->id);

				ExercicePeer::addSelectColumns($criteria);
				if (!isset($this->lastExerciceCriteria) || !$this->lastExerciceCriteria->equals($criteria)) {
					$this->collExercices = ExercicePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastExerciceCriteria = $criteria;
		return $this->collExercices;
	}

	/**
	 * Returns the number of related Exercice objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Exercice objects.
	 * @throws     PropelException
	 */
	public function countExercices(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collExercices === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ExercicePeer::PROFESSEUR_ID, $this->id);

				$count = ExercicePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ExercicePeer::PROFESSEUR_ID, $this->id);

				if (!isset($this->lastExerciceCriteria) || !$this->lastExerciceCriteria->equals($criteria)) {
					$count = ExercicePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collExercices);
				}
			} else {
				$count = count($this->collExercices);
			}
		}
		$this->lastExerciceCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a Exercice object to this object
	 * through the Exercice foreign key attribute.
	 *
	 * @param      Exercice $l Exercice
	 * @return     void
	 * @throws     PropelException
	 */
	public function addExercice(Exercice $l)
	{
		if ($this->collExercices === null) {
			$this->initExercices();
		}
		if (!in_array($l, $this->collExercices, true)) { // only add it if the **same** object is not already associated
			array_push($this->collExercices, $l);
			$l->setUtilisateur($this);
		}
	}

	/**
	 * Clears out the collJExeReponses collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addJExeReponses()
	 */
	public function clearJExeReponses()
	{
		$this->collJExeReponses = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collJExeReponses collection (array).
	 *
	 * By default this just sets the collJExeReponses collection to an empty array (like clearcollJExeReponses());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initJExeReponses()
	{
		$this->collJExeReponses = array();
	}

	/**
	 * Gets an array of JExeReponse objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Utilisateur has previously been saved, it will retrieve
	 * related JExeReponses from storage. If this Utilisateur is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array JExeReponse[]
	 * @throws     PropelException
	 */
	public function getJExeReponses($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJExeReponses === null) {
			if ($this->isNew()) {
			   $this->collJExeReponses = array();
			} else {

				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				JExeReponsePeer::addSelectColumns($criteria);
				$this->collJExeReponses = JExeReponsePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				JExeReponsePeer::addSelectColumns($criteria);
				if (!isset($this->lastJExeReponseCriteria) || !$this->lastJExeReponseCriteria->equals($criteria)) {
					$this->collJExeReponses = JExeReponsePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJExeReponseCriteria = $criteria;
		return $this->collJExeReponses;
	}

	/**
	 * Returns the number of related JExeReponse objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related JExeReponse objects.
	 * @throws     PropelException
	 */
	public function countJExeReponses(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collJExeReponses === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				$count = JExeReponsePeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				if (!isset($this->lastJExeReponseCriteria) || !$this->lastJExeReponseCriteria->equals($criteria)) {
					$count = JExeReponsePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collJExeReponses);
				}
			} else {
				$count = count($this->collJExeReponses);
			}
		}
		$this->lastJExeReponseCriteria = $criteria;
		return $count;
	}

	/**
	 * Method called to associate a JExeReponse object to this object
	 * through the JExeReponse foreign key attribute.
	 *
	 * @param      JExeReponse $l JExeReponse
	 * @return     void
	 * @throws     PropelException
	 */
	public function addJExeReponse(JExeReponse $l)
	{
		if ($this->collJExeReponses === null) {
			$this->initJExeReponses();
		}
		if (!in_array($l, $this->collJExeReponses, true)) { // only add it if the **same** object is not already associated
			array_push($this->collJExeReponses, $l);
			$l->setUtilisateur($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JExeReponses from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJExeReponsesJoinExercice($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJExeReponses === null) {
			if ($this->isNew()) {
				$this->collJExeReponses = array();
			} else {

				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				$this->collJExeReponses = JExeReponsePeer::doSelectJoinExercice($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

			if (!isset($this->lastJExeReponseCriteria) || !$this->lastJExeReponseCriteria->equals($criteria)) {
				$this->collJExeReponses = JExeReponsePeer::doSelectJoinExercice($criteria, $con, $join_behavior);
			}
		}
		$this->lastJExeReponseCriteria = $criteria;

		return $this->collJExeReponses;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Utilisateur is new, it will return
	 * an empty collection; or if this Utilisateur has previously
	 * been saved, it will retrieve related JExeReponses from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Utilisateur.
	 */
	public function getJExeReponsesJoinJDocQuestion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UtilisateurPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collJExeReponses === null) {
			if ($this->isNew()) {
				$this->collJExeReponses = array();
			} else {

				$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

				$this->collJExeReponses = JExeReponsePeer::doSelectJoinJDocQuestion($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(JExeReponsePeer::ELEVE_ID, $this->id);

			if (!isset($this->lastJExeReponseCriteria) || !$this->lastJExeReponseCriteria->equals($criteria)) {
				$this->collJExeReponses = JExeReponsePeer::doSelectJoinJDocQuestion($criteria, $con, $join_behavior);
			}
		}
		$this->lastJExeReponseCriteria = $criteria;

		return $this->collJExeReponses;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collJProfesseurClassess) {
				foreach ((array) $this->collJProfesseurClassess as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJProfesseurPrincipalClassess) {
				foreach ((array) $this->collJProfesseurPrincipalClassess as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collLogs) {
				foreach ((array) $this->collLogs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collQuestions) {
				foreach ((array) $this->collQuestions as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collReponseQuestions) {
				foreach ((array) $this->collReponseQuestions as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collCompetences) {
				foreach ((array) $this->collCompetences as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJCompetencesProfesseurss) {
				foreach ((array) $this->collJCompetencesProfesseurss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJCompetencegrpUtilisateurs) {
				foreach ((array) $this->collJCompetencegrpUtilisateurs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGrilles) {
				foreach ((array) $this->collGrilles as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJGrilleUtilisateurs) {
				foreach ((array) $this->collJGrilleUtilisateurs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJControlePossesseurs) {
				foreach ((array) $this->collJControlePossesseurs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJControleResultats) {
				foreach ((array) $this->collJControleResultats as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJGroupePossesseurs) {
				foreach ((array) $this->collJGroupePossesseurs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJGroupeEleves) {
				foreach ((array) $this->collJGroupeEleves as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collBilansRelatedByProfesseurId) {
				foreach ((array) $this->collBilansRelatedByProfesseurId as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collBilansRelatedByEleveId) {
				foreach ((array) $this->collBilansRelatedByEleveId as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collAppreciationsRelatedByProfesseurId) {
				foreach ((array) $this->collAppreciationsRelatedByProfesseurId as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collAppreciationsRelatedByEleveId) {
				foreach ((array) $this->collAppreciationsRelatedByEleveId as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJDiscussionUtilisateurss) {
				foreach ((array) $this->collJDiscussionUtilisateurss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collEchanges) {
				foreach ((array) $this->collEchanges as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJDiscussionDocumentss) {
				foreach ((array) $this->collJDiscussionDocumentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collRessources) {
				foreach ((array) $this->collRessources as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collAttestations) {
				foreach ((array) $this->collAttestations as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collExercices) {
				foreach ((array) $this->collExercices as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collJExeReponses) {
				foreach ((array) $this->collJExeReponses as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collJProfesseurClassess = null;
		$this->collJProfesseurPrincipalClassess = null;
		$this->collLogs = null;
		$this->collQuestions = null;
		$this->collReponseQuestions = null;
		$this->collCompetences = null;
		$this->collJCompetencesProfesseurss = null;
		$this->collJCompetencegrpUtilisateurs = null;
		$this->collGrilles = null;
		$this->collJGrilleUtilisateurs = null;
		$this->collJControlePossesseurs = null;
		$this->collJControleResultats = null;
		$this->collJGroupePossesseurs = null;
		$this->collJGroupeEleves = null;
		$this->collBilansRelatedByProfesseurId = null;
		$this->collBilansRelatedByEleveId = null;
		$this->collAppreciationsRelatedByProfesseurId = null;
		$this->collAppreciationsRelatedByEleveId = null;
		$this->collJDiscussionUtilisateurss = null;
		$this->collEchanges = null;
		$this->collJDiscussionDocumentss = null;
		$this->collRessources = null;
		$this->collAttestations = null;
		$this->collExercices = null;
		$this->collJExeReponses = null;
			$this->aetablissement = null;
			$this->arole = null;
			$this->aMatiere = null;
			$this->aClasse = null;
	}

} // BaseUtilisateur
